package ru.crp.lvms.cluster;

import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.lvms.cluster.model.ClusterEntity;
import ru.crp.lvms.cluster.model.ClusterType;
import ru.crp.lvms.model.dao.BaseSpaceDao;

import java.util.List;

@Transactional(propagation = Propagation.REQUIRED)
@Repository
public class ClusterDao extends BaseSpaceDao<ClusterEntity> {
    public List<ClusterEntity> getClustersByType(ClusterType clusterType) {
        return find("WHERE type_id = ?", clusterType.getId());
    }

    public ClusterType getClusterType(int clusterId) {
        return findOne(clusterId).getType();
    }
}
