package ru.crp.lvms.cluster.model;

import java.util.stream.Stream;

public enum ClusterType {
    // WARN! this constant is used in sql migration. See V80__Adding-clusters
    Space(1),
    Slurm(2);

    private int id;

    ClusterType(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    public static ClusterType valueOf(int id) {
        return Stream.of(ClusterType.values())
                .filter(ct -> ct.getId() == id)
                .findFirst().orElseThrow(() -> new IllegalArgumentException(String.format("Unexpected id %d", id)));
    }
}
