package ru.crp.lvms.cluster.model;

import java.util.Random;

public class NodePropertyInfo {
    public static final Random random = new Random();
    private int free;
    private int acquired;
    private int unavailable;
    private int disabled;

    public static NodePropertyInfo createEmptyInfo() {
        NodePropertyInfo propertyInfo = new NodePropertyInfo();
        propertyInfo.acquired = 0;
        propertyInfo.free = 0;
        propertyInfo.unavailable = 0;
        propertyInfo.disabled = 0;

        return propertyInfo;
    }

    public static NodePropertyInfo createRandomInfo() {
        NodePropertyInfo propertyInfo = new NodePropertyInfo();
        propertyInfo.acquired = Math.abs(random.nextInt());
        propertyInfo.free = Math.abs(random.nextInt());
        propertyInfo.unavailable = Math.abs(random.nextInt());
        propertyInfo.disabled = Math.abs(random.nextInt());
        return propertyInfo;
    }

    public static Random getRandom() {
        return random;
    }

    public int getFree() {
        return free;
    }

    public int getAcquired() {
        return acquired;
    }

    public int getUnavailable() {
        return unavailable;
    }

    public int getDisabled() {
        return disabled;
    }

    public void addUnavailable(int count) {
        unavailable += count;
    }

    public void addFree(int count) {
        free += count;
    }

    public void addAcquired(int count) {
        acquired += count;
    }

    public void addDisabled(int count) {
        disabled += count;
    }
}
