package ru.crp.lvms.events;


import ru.crp.lvms.model.entities.nodes.NodeEntity;

import javax.annotation.Nullable;

public class NodeStatusUpdatedEvent {
    private NodeEntity oldStatus;
    private NodeEntity newStatus;

    public NodeStatusUpdatedEvent(@Nullable NodeEntity oldStatus, @Nullable NodeEntity newStatus) {
        if (oldStatus == null && newStatus == null) {
            throw new IllegalArgumentException("Both old and new status null");
        }
        this.oldStatus = oldStatus;
        this.newStatus = newStatus;
    }

    @Nullable
    public NodeEntity getOldStatus() {
        return oldStatus;
    }

    @Nullable
    public NodeEntity getNewStatus() {
        return newStatus;
    }
}
