package ru.crp.lvms.exceptions;

import javax.validation.ConstraintViolation;
import java.util.List;
import java.util.Set;

import static java.util.Arrays.asList;
import static java.util.stream.Collectors.toList;

public class ValidationException extends RuntimeException {
    private List<String> constraintViolationMessages;

    public ValidationException(String... constraintViolationMessages) {
        this(asList(constraintViolationMessages));
    }

    public ValidationException(List<String> constraintViolationMessages) {
        this.constraintViolationMessages = constraintViolationMessages;
    }

    public List<String> getConstraintViolationMessages() {
        return constraintViolationMessages;
    }

    public static <T> List<String> extractMessages(Set<ConstraintViolation<T>> constraintViolations) {
        return constraintViolations.stream()
                .map(ConstraintViolation::getMessage)
                .collect(toList());
    }
}
