package ru.crp.lvms.managers.misc;

import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.cmlb.model.SuggestRequest;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.entities.UserEntity;

import java.util.List;
import java.util.Map;

public abstract class BaseManagerSuggest<E extends Entity>
        extends BaseManager<E> {

    @Transactional(readOnly = true)
    public List<E> suggest(SuggestRequest suggestRequest, UserEntity currentUser) {
        return aliveDao().suggest(suggestRequest, currentUser.getId());
    }

    public PageImpl<E> findByOwnerId(int id, Map<String, Object> filters, Pageable pageable, UserEntity currentUser) {
        return aliveDao().findByOwnerId(id, filters, pageable);
    }

    public List<E> findByOwnerId(int ownerId, UserEntity currentUser) {
        return aliveDao().findByOwnerId(ownerId);
    }
}
