package ru.crp.lvms.managers.tasks.resultsHandlers;

import org.apache.commons.io.FilenameUtils;
import ru.crp.cmls.calculations.solvers.xml.config.ResultType;
import ru.crp.lvms.managers.tasks.ResultsParent;
import ru.crp.lvms.model.entities.ResultEntity;
import ru.crp.lvms.model.entities.misc.CreatedBy;

import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;

import static java.util.Collections.singletonList;

public class AnimationResultHandler extends KeyResultHandler {

    public AnimationResultHandler(Path pathToStorage) {
        super(pathToStorage);
    }

    @Override
    public boolean canHandle(ResultType resultType, Path pathToFile) {
        return resultType == ResultType.animations && Files.isRegularFile(pathToFile) && isAnimation(pathToFile);
    }

    @Override
    protected List<ResultEntity> doHandleResultsFile(Path pathToFile, ResultsParent resultsParent, CreatedBy createdBy) {
        ResultEntity newAnimation = initCommonResultProperties(pathToFile, resultsParent, createdBy);
        if (createdBy == CreatedBy.Auto) {
            extractDescription(pathToFile, newAnimation);
        }

        newAnimation.setName(FilenameUtils.removeExtension(pathToFile.getFileName().toString()));
        newAnimation.setType(ResultType.animations);

        return singletonList(newAnimation);
    }


    private boolean isAnimation(Path animationFile) {
        String extension = FilenameUtils.getExtension(animationFile.toString());
        return "gif".equalsIgnoreCase(extension);
    }
}
