package ru.crp.lvms.managers.tasks.resultsHandlers;

import org.apache.commons.io.FilenameUtils;
import ru.crp.cmls.calculations.solvers.xml.config.ResultType;
import ru.crp.lvms.managers.tasks.ResultsParent;
import ru.crp.lvms.model.entities.ResultEntity;
import ru.crp.lvms.model.entities.misc.CreatedBy;

import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;

import static java.util.Collections.singletonList;

public class OptistructResultHandler extends KeyResultHandler {

    public OptistructResultHandler(Path pathToStorage) {
        super(pathToStorage);
    }

    @Override
    public boolean canHandle(ResultType resultType, Path pathToFile) {
        return resultType == ResultType.optistructModel && Files.isRegularFile(pathToFile) && !isFEMFile(pathToFile);
    }

    private boolean isFEMFile(Path pathToFile) {
        String extension = FilenameUtils.getExtension(pathToFile.getFileName().toString());
        return extension != null && extension.equalsIgnoreCase("fem");
    }

    @Override
    protected List<ResultEntity> doHandleResultsFile(Path pathToFile, ResultsParent resultsParent, CreatedBy createdBy) {
        ResultEntity optistructResult = initCommonResultProperties(pathToFile, resultsParent, createdBy);
        optistructResult.setName(FilenameUtils.removeExtension(pathToFile.getFileName().toString()));
        optistructResult.setType(ResultType.optistructModel);

        return singletonList(optistructResult);
    }
}

