package ru.crp.lvms.model.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.entities.ParametersEntityTable;

import java.util.List;

@Repository
public class ParametersDao extends BaseSpaceDao<ParametersEntityTable> {
    public static final int MATERIALS_PARAMETERS = 0;
    public static final int COMPOSITE_MATERIALS_PARAMETERS = 1;
    public static final int BOTH_MATERIALS_PARAMETERS = 2;

    public boolean exists(int parameterId, boolean isComposite) {
        int materialRelation = isComposite ? COMPOSITE_MATERIALS_PARAMETERS : MATERIALS_PARAMETERS;
        return findOne("WHERE material_relation IN (?, ?) AND id = ?",
                materialRelation, BOTH_MATERIALS_PARAMETERS, parameterId) != null;
    }

    public List<ParametersEntityTable> findAllForMaterialType(boolean isComposite) {
        int materialRelation = isComposite ? COMPOSITE_MATERIALS_PARAMETERS : MATERIALS_PARAMETERS;
        return find("WHERE material_relation IN (?, ?) ORDER BY ordering ", materialRelation, BOTH_MATERIALS_PARAMETERS);
    }
}
