package ru.crp.lvms.model.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.entities.effective.characteristics.ECParamEntity;
import ru.crp.lvms.model.entities.technology.TechnologySimulationsParamEntity;

import java.util.List;

@Repository
public class TechnologySimulationsParamDao extends BaseSpaceDao<TechnologySimulationsParamEntity> {
    public List<TechnologySimulationsParamEntity> getByTechnologyId(Integer technologySimulationsId) {
        return find("WHERE technology_simulations_id = ? ORDER BY param_id", technologySimulationsId);
    }


    public TechnologySimulationsParamEntity findOne(Integer id, Integer technologySimulationsId) {
        return findOne("WHERE id = ? AND technology_simulations_id = ?", id, technologySimulationsId);
    }

    public TechnologySimulationsParamEntity getByTechnologyIdAndParamId(Integer technologySimulationsId, Integer paramId) {
        return findOne("WHERE technology_simulations_id = ? AND param_id = ?", technologySimulationsId, paramId);
    }

    public List<Integer> getAllParamIds() {
        return jdbcTemplate().queryForList("SELECT id FROM technology_simulations_parameters", Integer.class);
    }


}
