package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.web.dto.columns.GridColumn;

import javax.validation.constraints.NotNull;

@Table("equipments")
public class EquipmentEntity implements Entity, Named {
    private int id;

    @GridColumn(name = "name", label = "Название", order = 1)
    @NotNull(message = "Название оборудования должно быть задано")
    @Column("name")
    private String name;

    @GridColumn(name = "manufacturer", label = "Изготовитель", order = 2)
    @NotNull(message = "Изготовитель оборудования должен быть задан")
    @Column("manufacturer")
    private String manufacturer;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }
}
