package ru.crp.lvms.model.entities;

import com.fasterxml.jackson.annotation.JsonInclude;
import ru.crp.lvms.web.dto.misc.ValueObject;

import javax.annotation.Nullable;
import java.math.BigDecimal;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class ParameterSample extends ValueObject {
    private Integer id;
    private BigDecimal temperature;
    private BigDecimal paramValue;
    private BigDecimal funcParamValue;
    private BigDecimal simParamValue;

    public ParameterSample() {
    }

    public ParameterSample(Integer id, BigDecimal temperature, BigDecimal paramValue, @Nullable BigDecimal funcParamValue,
                           @Nullable BigDecimal simParamValue) {
        this.temperature = temperature;
        this.paramValue = paramValue;
        this.funcParamValue = funcParamValue;
        this.simParamValue = simParamValue;
        this.id = id;
    }

    public BigDecimal getTemperature() {
        return temperature;
    }

    public void setTemperature(BigDecimal temperature) {
        this.temperature = temperature;
    }

    public BigDecimal getParamValue() {
        return paramValue;
    }

    public void setParamValue(BigDecimal paramValue) {
        this.paramValue = paramValue;
    }

    public BigDecimal getFuncParamValue() {
        return funcParamValue;
    }

    public void setFuncParamValue(@Nullable BigDecimal funcParamValue) {
        this.funcParamValue = funcParamValue;
    }

    public BigDecimal getSimParamValue() {
        return simParamValue;
    }

    public void setSimParamValue(@Nullable BigDecimal simParamValue) {
        this.simParamValue = simParamValue;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }
}
