package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.web.dto.user.UserRole;

import javax.annotation.Nonnull;

@Table("users_join")
public class UserEntity extends UserEntityTable {
    @Column("role")
    private UserRole role;

    @Nonnull
    public UserRole getRole() {
        return role;
    }

    public void setRole(UserRole role) {
        this.role = role;
    }

    @Override
    public void setRoleId(int roleId) {
        super.setRoleId(roleId);
        role = UserRole.valueOf(roleId);
    }

    public boolean isAdmin() {
        return role == UserRole.Administrator;
    }

    public boolean isGuest() {
        return role == UserRole.Guest;
    }
}
