package ru.crp.lvms.model.entities.effective.characteristics;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.model.entities.simulations.SolvingStatus;
import ru.crp.lvms.model.entities.tasks.TaskParent;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.annotation.Nullable;
import java.util.List;

import static java.util.Collections.emptyList;

@Table("effective_characteristics_join")
public class ECEntity extends ECEntityTable implements TaskParent {
    @GridColumn(name = "owner", label = "Автор", cell = GridColumnType.uri, order = 3)
    @Column("owner")
    private String owner;

    @GridColumn(name = "compositeMaterialName", label = "Композиционный материал", cell = GridColumnType.uri, order = 4)
    @Column("composite_material_name")
    private String compositeMaterialName;

    @Nullable
    @GridColumn(name = "microstructureFileName", label = "Файл микроструктуры", cell = GridColumnType.uri, order = 5)
    @Column("microstructure_file_name")
    private String microstructureFileName;

    @Column(value = "results_count", onlySelect = true)
    private Integer resultsCount;

    private List<ECDefectEntity> defects = emptyList();

    private List<ECParamEntity> params = emptyList();

    private SolvingStatus status;

    @Column("average_thickness_is_setable")
    private boolean averageThicknessIsSetable;

    public boolean getAverageThicknessIsSetable() {
        return averageThicknessIsSetable;
    }

    public void setAverageThicknessIsSetable(boolean averageThicknessIsSetable) {
        this.averageThicknessIsSetable = averageThicknessIsSetable;
    }


    @Override
    public void setStatusId(int statusId) {
        super.setStatusId(statusId);
        status = SolvingStatus.valueOf(statusId);
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getCompositeMaterialName() {
        return compositeMaterialName;
    }

    public void setCompositeMaterialName(String compositeMaterialName) {
        this.compositeMaterialName = compositeMaterialName;
    }

    @Nullable
    public String getMicrostructureFileName() {
        return microstructureFileName;
    }

    public void setMicrostructureFileName(@Nullable String microstructureFileName) {
        this.microstructureFileName = microstructureFileName;
    }

    public List<ECDefectEntity> getDefects() {
        return defects;
    }

    public void setDefects(List<ECDefectEntity> defects) {
        this.defects = defects;
    }

    public List<ECParamEntity> getParams() {
        return params;
    }

    public void setParams(List<ECParamEntity> params) {
        this.params = params;
    }

    public SolvingStatus getStatus() {
        return status;
    }

    public Integer getResultsCount() {
        return resultsCount;
    }

    public void setResultsCount(Integer resultsCount) {
        this.resultsCount = resultsCount;
    }
}
