package ru.crp.lvms.model.entities.misc;

import javax.annotation.Nonnull;

public enum FileType {
    MaterialFile(0),
    SampleFile(1),
    ParameterFile(2),
    CompositeMaterialFile(3),
    ImageFile(4),
    DescriptionFile(5),
    StandardFile(6),
    StandardLoadFile(7),
    CADFile(8),
    CAEFile(9),
    CAOFile(10),
    DesignSolutionFile(11),
    LoadCondition(12),
    DefectActFile(13),
    ExperimentalResultFile(14),
    ModFrontierScript(15),
    OptimusScript(16);

    private final int id;

    FileType(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    @Nonnull
    public static FileType valueOf(int id) {
        for (FileType type : values()) {
            if (type.getId() == id) {
                return type;
            }
        }
        throw new IllegalArgumentException("There is no file type with such id: " + id);
    }
}
