package ru.crp.lvms.optimizations.base.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.managers.misc.BaseManagerSuggest;
import ru.crp.lvms.managers.misc.EventManager;
import ru.crp.lvms.optimizations.base.entities.OptimizationType;
import ru.crp.lvms.optimizations.base.entities.SolverWithCompatibles;
import ru.crp.lvms.optimizations.base.managers.OptimizationTypeManager;
import ru.crp.lvms.security.CurrentUser;
import ru.crp.lvms.security.PortalUser;
import ru.crp.lvms.web.controllers.misc.CrudControllerSuggest;

import java.util.List;

import static ru.crp.lvms.utils.URLs.OPTIMIZATION_TYPES_URL;

@RestController
@RequestMapping(value = OPTIMIZATION_TYPES_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptimizationTypesController extends CrudControllerSuggest<OptimizationType,
        OptimizationType, OptimizationType> {
    @Autowired
    private OptimizationTypeManager optimizationTypeManager;

    @Autowired
    private EventManager eventManager;

    @Override
    protected BaseManagerSuggest<OptimizationType> getManager() {
        return optimizationTypeManager;
    }

    @Override
    protected EventManager getEventsManager() {
        return eventManager;
    }

    @RequestMapping(value = "/{id}/cae", method = RequestMethod.POST)
    public List<SolverWithCompatibles> getCaes(@PathVariable("id") int optimizationTypeId, @CurrentUser PortalUser currentUser) {
        return optimizationTypeManager.getCaes(optimizationTypeId, currentUser);
    }

    @RequestMapping(value = "/{id}/cao", method = RequestMethod.POST)
    public List<SolverWithCompatibles> getCaos(@PathVariable("id") int optimizationTypeId, @CurrentUser PortalUser currentUser) {
        return optimizationTypeManager.getCaos(optimizationTypeId, currentUser);
    }

    @RequestMapping(value = "/{id}/cad", method = RequestMethod.POST)
    public List<SolverWithCompatibles> getCads(@PathVariable("id") int optimizationTypeId, @CurrentUser PortalUser currentUser) {
        return optimizationTypeManager.getCads(optimizationTypeId, currentUser);
    }
}
