package ru.crp.lvms.optimizations.base.entities;

import ru.crp.lvms.optimizations.base.enums.OptimizationCad;
import ru.crp.lvms.optimizations.base.enums.OptimizationCae;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;

import java.util.ArrayList;
import java.util.List;

import static java.util.stream.Collectors.toList;

public class CaeWithCompatibles implements SolverWithCompatibles {

    private final String type = "CAE";

    private int id;

    private String name;

    private List<OptimizationCao> compatibleCAO;

    private List<OptimizationCad> compatibleCAD;

    public CaeWithCompatibles() {
    }

    public CaeWithCompatibles(int id, List<OptimizationTypeSolverCombination> combinations) {
        this.id = id;
        this.name = OptimizationCae.valueOf(id).name();
        this.compatibleCAO = combinations.stream()
                .map(OptimizationTypeSolverCombination::getCaoId)
                .filter(caoId -> caoId != null)
                .map(OptimizationCao::valueOf)
                .collect(toList());
        this.compatibleCAD = combinations.stream()
                .map(OptimizationTypeSolverCombination::getCadId)
                .filter(cadId -> cadId != null)
                .map(OptimizationCad::valueOf)
                .collect(toList());
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<OptimizationCao> getCompatibleCAO() {
        return compatibleCAO;
    }

    public void setCompatibleCAO(List<OptimizationCao> compatibleCAO) {
        this.compatibleCAO = new ArrayList<>(compatibleCAO);
    }

    public String getType() {
        return type;
    }

    public List<OptimizationCad> getCompatibleCAD() {
        return compatibleCAD;
    }

    public void setCompatibleCAD(List<OptimizationCad> compatibleCAD) {
        this.compatibleCAD = compatibleCAD;
    }
}
