package ru.crp.lvms.optimizations.base.entities;

import ru.crp.lvms.optimizations.base.enums.OptimizationCad;
import ru.crp.lvms.optimizations.base.enums.OptimizationCae;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;

import java.util.ArrayList;
import java.util.List;

import static java.util.stream.Collectors.toList;

public class CaoWithCompatibles implements SolverWithCompatibles {

    private final String type = "CAO";

    private int id;

    private String name;

    private List<OptimizationCae> compatibleCAE;

    private List<OptimizationCad> compatibleCAD;

    public CaoWithCompatibles() {
    }

    public CaoWithCompatibles(Integer id, List<OptimizationTypeSolverCombination> compatibles) {
        this.id = id;
        this.name = OptimizationCao.valueOf(id).name();
        this.compatibleCAE = compatibles.stream()
                .map(OptimizationTypeSolverCombination::getCaeId)
                .filter(caeId -> caeId != null)
                .map(OptimizationCae::valueOf)
                .collect(toList());
        this.compatibleCAD = compatibles.stream()
                .map(OptimizationTypeSolverCombination::getCadId)
                .filter(cadId -> cadId != null)
                .map(OptimizationCad::valueOf)
                .collect(toList());
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<OptimizationCae> getCompatibleCAE() {
        return compatibleCAE;
    }

    public void setCompatibleCAE(List<OptimizationCae> compatibleCAE) {
        this.compatibleCAE = new ArrayList<>(compatibleCAE);
    }

    public String getType() {
        return type;
    }

    public List<OptimizationCad> getCompatibleCAD() {
        return compatibleCAD;
    }

    public void setCompatibleCAD(List<OptimizationCad> compatibleCAD) {
        this.compatibleCAD = compatibleCAD;
    }
}
