package ru.crp.lvms.optimizations.base.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

@Table("enabled_optimization_types")
public class OptimizationType implements Entity {
    public static final int ENGINEERING_CALCULATION_TYPE_ID = 1;
    public static final int TOPOLOGICAL_OPTIMIZATION_TYPE_ID = 2;
    public static final int TOPOGRAPHIC_OPTIMIZATION_TYPE_ID = 3;
    public static final int SHAPE_OPTIMIZATION_TYPE_ID = 7;
    private int id;

    @Column("name")
    private String name;

    @JsonIgnore
    @Column("unique_name")
    private String uniqueName;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUniqueName() {
        return uniqueName;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }
}
