package ru.crp.lvms.optimizations.base.enums;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.annotation.Nonnull;
import java.util.Objects;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum OptimizationCao implements OptimizationSolver {
    Tosca("TOSCA", "Tosca"),
    ModeFrontier("MODEFRONTIER", "ModeFrontier"),
    Optistruct("OPTISTRUCT", "Optistruct"),
    Optimus("OPTIMUS", "Optimus");

    private int id;

    private String uniqueName;

    private String solverConfigName;

    OptimizationCao(String uniqueName, String solverConfigName) {
        this.uniqueName = uniqueName;
        this.solverConfigName = solverConfigName;
    }

    public String getSolverConfigName() {
        return solverConfigName;
    }

    public void setSolverConfigName(String solverConfigName) {
        this.solverConfigName = solverConfigName;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    @JsonIgnore
    public String getUniqueName() {
        return uniqueName;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }

    @Nonnull
    public static OptimizationCao valueOf(Integer id) {
        for (OptimizationCao type : values()) {
            if (type.getId() == id) {
                return type;
            }
        }
        throw new IllegalArgumentException("There is no cao with such id: " + id);
    }

    @Nonnull
    public static OptimizationCao fromUniqueName(String uniqueName) {
        for (OptimizationCao type : values()) {
            if (Objects.equals(type.getUniqueName(), uniqueName)) {
                return type;
            }
        }
        throw new IllegalArgumentException("There is no cao with such unique name: " + uniqueName);
    }

    public String getName() {
        return this.name();
    }
}
