package ru.crp.lvms.optimizations.mf.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.mf.entities.MFOptimizationVaryingParam;
import ru.crp.lvms.optimizations.mf.enums.MFBaseSettingType;
import ru.crp.lvms.optimizations.mf.enums.MFSettingsType;
import ru.crp.lvms.optimizations.mf.managers.MFOptimizationSettingsManager;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsManager;
import ru.crp.lvms.utils.URLs;

@RestController
@RequestMapping(value = URLs.MF_VARYING_PARAMS_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class MFVaryingParamController extends AbstractOptimizationSettingsController<MFOptimizationVaryingParam, MFSettingsType> {

    @Autowired
    private MFOptimizationSettingsManager MFOptimizationSettingsManager;

    @Override
    protected MFSettingsType getSettingsType() {
        return MFSettingsType.VaryingParam;
    }

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return MFOptimizationSettingsManager
                .getBaseSettingsByType(optimizationId, MFBaseSettingType.NUM_CAO_VARYING_PARAMS)
                .getCurrentValue();
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.ModeFrontier;
    }

    @Override
    protected AbstractOptimizationSettingsManager getSettingsManager() {
        return MFOptimizationSettingsManager;
    }
}
