package ru.crp.lvms.optimizations.mf.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;

@Table("optimization_varying_params_join")
public class MFOptimizationVaryingParam extends AbstractOptimizationSettings {
    @Column("lower_bound")
    private Double lowerBound;

    @Column("upper_bound")
    private Double upperBound;

    @Column("sampling")
    private Integer sampling;

    @Column(value = "is_used_in_script", onlySelect = true)
    private boolean isUsedInScript;

    public MFOptimizationVaryingParam() {
        super();
    }

    // For tests
    public MFOptimizationVaryingParam(Integer id, Double lowerBound, Double upperBound) {
        setId(id);
        this.lowerBound = lowerBound;
        this.upperBound = upperBound;
    }

    public MFOptimizationVaryingParam(int optimizationId, String name) {
        super(optimizationId, name);
    }

    public Double getLowerBound() {
        return lowerBound;
    }

    public void setLowerBound(Double lowerBound) {
        this.lowerBound = lowerBound;
    }

    public Double getUpperBound() {
        return upperBound;
    }

    public void setUpperBound(Double upperBound) {
        this.upperBound = upperBound;
    }

    public Integer getSampling() {
        return sampling;
    }

    public void setSampling(Integer sampling) {
        this.sampling = sampling;
    }

    public boolean getIsUsedInScript() {
        return isUsedInScript;
    }

    public void setIsUsedInScript(boolean usedInScript) {
        isUsedInScript = usedInScript;
    }
}
