
package ru.crp.lvms.optimizations.optimus.config.xml;


import javax.xml.bind.annotation.*;
import java.util.ArrayList;
import java.util.List;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EXPERIMENTType", propOrder = {
    "numpoints","goal","objective","nrexpfirstlh","seed","maxnumeval",
        "tolerance","modeltype","theta","nugget", "intensivesearch",
        "updatefreq","rbftype","rbffactor","nrsigma","opt","savelastkrigingmodel",
        "inittemp","annealfactor","stepwidthadjfactor","numcycles","iterattconst",
        "avgstopwidth","maxeval"
})

public class ExperimentType {

    @XmlAttribute(name = "type")
    private String type;

    @XmlAttribute(name = "algorithm")
    private String algorithm;

    @XmlAttribute(name = "method")
    private String method;

    @XmlElement(name = "numpoints", required = true)
    private String numpoints;

    @XmlElement(name = "goal", required = true)
    private String goal;

    @XmlElement(name = "objective", required = true)
    private String objective;

    @XmlElement(name = "nrexpfirstlh", required = true)
    private String nrexpfirstlh;

    @XmlElement(name = "seed", required = true)
    private String seed;

    @XmlElement(name = "maxnumeval", required = true)
    private String maxnumeval;

    @XmlElement(name = "tolerance", required = true)
    private String tolerance;

    @XmlElement(name = "modeltype", required = true)
    private String modeltype;

    @XmlElement(name = "theta", required = true)
    private String theta;

    @XmlElement(name = "nugget", required = true)
    private String nugget;

    @XmlElement(name = "intensivesearch", required = true)
    private String intensivesearch;

    @XmlElement(name = "updatefreq", required = true)
    private String updatefreq;

    @XmlElement(name = "rbftype", required = true)
    private String rbftype;

    @XmlElement(name = "rbffactor", required = true)
    private String rbffactor;

    @XmlElement(name = "nrsigma", required = true)
    private String nrsigma;

    @XmlElement(name = "opt", required = true)
    private String opt;

    @XmlElement(name = "savelastkrigingmodel", required = true)
    private String savelastkrigingmodel;

    @XmlElement(name = "inittemp", required = true)
    private String inittemp;

    @XmlElement(name = "annealfactor", required = true)
    private String annealfactor;

    @XmlElement(name = "stepwidthadjfactor", required = true)
    private String stepwidthadjfactor;

    @XmlElement(name = "numcycles", required = true)
    private String numcycles;

    @XmlElement(name = "iterattconst", required = true)
    private String iterattconst;

    @XmlElement(name = "avgstopwidth", required = true)
    private String avgstopwidth;

    @XmlElement(name = "maxeval", required = true)
    private String maxeval;

    public ExperimentType() {
    }

    public ExperimentType(String goal) {

        this.goal = goal;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getAlgorithm() {
        return algorithm;
    }

    public void setAlgorithm(String algorithm) {
        this.algorithm = algorithm;
    }

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }
    public String getGoal() {
        return goal;
    }

    public void setGoal(String goal) {
        this.goal = goal;
    }

    public String getNumpoints() {
        return numpoints;
    }

    public void setNumpoints(String numpoints) {
        this.numpoints = numpoints;
    }

    public String getObjective() {
        return objective;
    }

    public void setObjective(String objective) {
        this.objective = objective;
    }

    public String getNrexpfirstlh() {
        return nrexpfirstlh;
    }

    public void setNrexpfirstlh(String nrexpfirstlh) {
        this.nrexpfirstlh = nrexpfirstlh;
    }

    public String getSeed() {
        return seed;
    }

    public void setSeed(String seed) {
        this.seed = seed;
    }

    public String getMaxnumeval() {
        return maxnumeval;
    }

    public void setMaxnumeval(String maxnumeval) {
        this.maxnumeval = maxnumeval;
    }

    public String getTolerance() {
        return tolerance;
    }

    public void setTolerance(String tolerance) {
        this.tolerance = tolerance;
    }

    public String getModeltype() {
        return modeltype;
    }

    public void setModeltype(String modeltype) {
        this.modeltype = modeltype;
    }

    public String getTheta() {
        return theta;
    }

    public void setTheta(String theta) {
        this.theta = theta;
    }

    public String getNugget() {
        return nugget;
    }

    public void setNugget(String nugget) {
        this.nugget = nugget;
    }

    public String getIntensivesearch() {
        return intensivesearch;
    }

    public void setIntensivesearch(String intensivesearch) {
        this.intensivesearch = intensivesearch;
    }

    public String getUpdatefreq() {
        return updatefreq;
    }

    public void setUpdatefreq(String updatefreq) {
        this.updatefreq = updatefreq;
    }

    public String getRbftype() {
        return rbftype;
    }

    public void setRbftype(String rbftype) {
        this.rbftype = rbftype;
    }

    public String getRbffactor() {
        return rbffactor;
    }

    public void setRbffactor(String rbffactor) {
        this.rbffactor = rbffactor;
    }

    public String getNrsigma() {
        return nrsigma;
    }

    public void setNrsigma(String nrsigma) {
        this.nrsigma = nrsigma;
    }

    public String getOpt() {
        return opt;
    }

    public void setOpt(String opt) {
        this.opt = opt;
    }

    public String getSavelastkrigingmodel() {
        return savelastkrigingmodel;
    }

    public void setSavelastkrigingmodel(String savelastkrigingmodel) {
        this.savelastkrigingmodel = savelastkrigingmodel;
    }

    public String getInittemp() {
        return inittemp;
    }

    public void setInittemp(String inittemp) {
        this.inittemp = inittemp;
    }

    public String getAnnealfactor() {
        return annealfactor;
    }

    public void setAnnealfactor(String annealfactor) {
        this.annealfactor = annealfactor;
    }

    public String getStepwidthadjfactor() {
        return stepwidthadjfactor;
    }

    public void setStepwidthadjfactor(String stepwidthadjfactor) {
        this.stepwidthadjfactor = stepwidthadjfactor;
    }

    public String getNumcycles() {
        return numcycles;
    }

    public void setNumcycles(String numcycles) {
        this.numcycles = numcycles;
    }

    public String getIterattconst() {
        return iterattconst;
    }

    public void setIterattconst(String iterattconst) {
        this.iterattconst = iterattconst;
    }

    public String getAvgstopwidth() {
        return avgstopwidth;
    }

    public void setAvgstopwidth(String avgstopwidth) {
        this.avgstopwidth = avgstopwidth;
    }

    public String getMaxeval() {
        return maxeval;
    }

    public void setMaxeval(String maxeval) {
        this.maxeval = maxeval;
    }

}


