package ru.crp.lvms.optimizations.optimus.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.mf.entities.MFOptimizationCADVaryingParam;
import ru.crp.lvms.optimizations.mf.enums.MFBaseSettingType;
import ru.crp.lvms.optimizations.mf.enums.MFSettingsType;
import ru.crp.lvms.optimizations.mf.managers.MFOptimizationSettingsManager;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsManager;
import ru.crp.lvms.optimizations.optimus.entities.OptimusOptimizationCADVaryingParam;
import ru.crp.lvms.optimizations.optimus.enums.OptimusBaseSettingType;
import ru.crp.lvms.optimizations.optimus.enums.OptimusSettingsType;
import ru.crp.lvms.optimizations.optimus.managers.OptimusOptimizationSettingsManager;
import ru.crp.lvms.utils.URLs;

@RestController
@RequestMapping(value = URLs.OPTIMUS_CAD_VARYING_PARAMS_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptimusCADVaryingParamController extends AbstractOptimizationSettingsController<OptimusOptimizationCADVaryingParam, OptimusSettingsType> {

    @Autowired
    private OptimusOptimizationSettingsManager optimusOptimizationSettingsManager;

    @Override
    protected OptimusSettingsType getSettingsType() {
        return OptimusSettingsType.CADVaryingParam;
    }

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return optimusOptimizationSettingsManager
                .getBaseSettingsByType(optimizationId, OptimusBaseSettingType.NUM_CAD_VARYING_PARAMS)
                .getCurrentValue();
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Optimus;
    }

    @Override
    protected AbstractOptimizationSettingsManager getSettingsManager() {
        return optimusOptimizationSettingsManager;
    }
}
