package ru.crp.lvms.optimizations.optimus.enums;

import ru.crp.lvms.model.entities.modfrontier.ParametersDictionary;

import java.util.stream.Stream;

import static ru.crp.lvms.optimizations.optimus.managers.OptimusDefaultParamsCreator.*;

public enum OptimusAlgorithmType {
    EGO(EGO_METHOD_ID),
    SIMAN(SIMAN_METHOD_ID),
    DOE(DOE_METHOD_ID);

    private int id;

    OptimusAlgorithmType(int id) {
        this.id = id;
    }

    public static OptimusAlgorithmType map(ParametersDictionary algorithm) {
        return Stream.of(values())
                .filter(val -> val.id == algorithm.getId())
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected algorithm id " + algorithm.getId()));
    }

    public int getId() {
        return id;
    }
}
