package ru.crp.lvms.optimizations.optistruct.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructBaseSettingType;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructSettingsType;
import ru.crp.lvms.optimizations.optistruct.managers.OptistructOptimizationSettingsManager;

public abstract class OptistructAbstractOptimizationSettingsController<T extends AbstractOptimizationSettings>
        extends AbstractOptimizationSettingsController<T, OptistructSettingsType> {

    @Autowired
    private OptistructOptimizationSettingsManager optistructOptimizationSettingsManager;

    protected abstract OptistructBaseSettingType getOptistructOptimizationBaseSettingType();

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return optistructOptimizationSettingsManager
                .getBaseSettingsByType(optimizationId, getOptistructOptimizationBaseSettingType())
                .getCurrentValue();
    }

    @Override
    protected OptistructOptimizationSettingsManager getSettingsManager() {
        return optistructOptimizationSettingsManager;
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Optistruct;
    }
}
