package ru.crp.lvms.optimizations.optistruct.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettignsDao;
import ru.crp.lvms.optimizations.optistruct.entities.OptistructOptimizationBaseSetting;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructBaseSettingType;

import javax.annotation.PostConstruct;

@Repository
public class OptistructOptimizationBaseSettingsDao extends AbstractOptimizationSettignsDao<OptistructOptimizationBaseSetting> {

    @PostConstruct
    private void init() {
        getJdbcTemplate().query("SELECT id, max_value, min_value, display_name FROM optistruct_optimization_base_setting_types", rs -> {
            OptistructBaseSettingType type = OptistructBaseSettingType.valueOf(rs.getInt("id"));
            type.setMaxValue(rs.getInt("max_value"));
            type.setMinValue(rs.getInt("min_value"));
            type.setDisplayName(rs.getString("display_name"));
        });
    }

    public OptistructOptimizationBaseSetting getBaseSettingsByType(int optimizationId, int typeId) {
        return findOne("WHERE optimization_id = ? AND type_id = ?", optimizationId, typeId);
    }
}
