package ru.crp.lvms.optimizations.optistruct.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettignsDao;
import ru.crp.lvms.optimizations.optistruct.entities.OptistructSet;

import java.util.ArrayList;
import java.util.List;

@Repository
public class OptistructOptimizationSetDao extends AbstractOptimizationSettignsDao<OptistructSet> {
    public List<OptistructSet> findSelectedSets(Integer optimizationId, Integer componentTypeId) {
        if (componentTypeId == null) {
            return find("WHERE optimization_id = ? AND is_selected = TRUE ORDER BY name", optimizationId);
        } else {
            return find("WHERE optimization_id = ? AND is_selected = TRUE AND set_type_id = ? ORDER BY name", optimizationId, componentTypeId);
        }
    }

    public void deleteAllForOptimization(Integer optimizationId) {
        jdbcTemplate().update("DELETE FROM " + getTableName() + " WHERE optimization_id = ?", optimizationId);
    }

    public void addSetsForOptimization(Integer optimizationId, List<OptistructSet> newSets) {
        List<Object[]> paramsInsert = new ArrayList<>();
        for (OptistructSet set : newSets) {
            paramsInsert.add(new Object[]{
                    optimizationId,
                    set.getName(),
                    set.getComponentTypeId(),
                    set.getIsSelected(),
                    set.getIsOptimizationSpace()
            });
        }
        if (!paramsInsert.isEmpty()) {
            getJdbcTemplate().batchUpdate(
                    "INSERT INTO " + getTableName() +
                            "(optimization_id," +
                            " name," +
                            " component_type_id," +
                            " is_selected," +
                            " is_optimization_space) " +
                            "VALUES (?, ?, ?, ?, ?)",
                    paramsInsert);
        }
    }
}
