package ru.crp.lvms.optimizations.optistruct.entities;

import com.fasterxml.jackson.annotation.JsonFormat;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.optistruct.enums.LnSetType;

import java.util.Objects;

@Table("optistruct_lnsets_join")
public class OptistructLnSet extends AbstractOptimizationSettings {

    @Column("is_selected")
    private boolean isSelected;

    @Column("lnset_type_id")
    private Integer lnSetTypeId;

    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @Column("lnset_type_name")
    private LnSetType lnSetTypeName;

    public OptistructLnSet() {
        super();
        this.isSelected = false;
    }

    public OptistructLnSet(int optimizationId, LnSetType lnSetTypeName, String name) {
        super(optimizationId, name);
        this.isSelected = false;
        this.lnSetTypeName = lnSetTypeName;
        this.lnSetTypeId = lnSetTypeName.getId();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        OptistructLnSet that = (OptistructLnSet) o;

        if (isSelected != that.isSelected) return false;
        if (getOptimizationId() != that.getOptimizationId()) return false;
        if (!Objects.equals(getName(), that.getName())) return false;
        if (getLnSetTypeId() != null ? !getLnSetTypeId().equals(that.getLnSetTypeId()) : that.getLnSetTypeId() != null)
            return false;
        return getLnSetTypeName() == that.getLnSetTypeName();

    }

    @Override
    public int hashCode() {
        int result =  (isSelected ? 1 : 0);
        result = 31 * result + (getLnSetTypeId() != null ? getLnSetTypeId().hashCode() : 0);
        result = 31 * result + (getLnSetTypeName() != null ? getLnSetTypeName().hashCode() : 0);
        return result;
    }

    public boolean getIsSelected() {
        return isSelected;
    }

    public void setIsSelected(boolean selected) {
        isSelected = selected;
    }

    public Integer getLnSetTypeId() {
        return lnSetTypeId;
    }

    public void setLnSetTypeId(Integer lnSetTypeId) {
        this.lnSetTypeId = lnSetTypeId;
    }

    public LnSetType getLnSetTypeName() {
        return lnSetTypeName;
    }

    public void setLnSetTypeName(LnSetType lnSetTypeName) {
        this.lnSetTypeName = lnSetTypeName;
    }
}
