package ru.crp.lvms.optimizations.optistruct.enums;

import ru.crp.lvms.optimizations.base.enums.BaseSetting;

import javax.annotation.Nonnull;

public enum OptistructBaseSettingType implements BaseSetting {
    NUM_TARGET_FUNCS(1),
    NUM_TECH_CONSTRAINTS(2),
    NUM_CONSTRAINTS(3),
    NUM_SETS(4),
    NUM_LOAD_STEPS(5),
    NUM_LNSETS(6);

    private int id;
    private int maxValue;
    private int minValue;
    private String displayName;

    OptistructBaseSettingType(int id) {
        this.id = id;
    }

    @Nonnull
    public static OptistructBaseSettingType valueOf(int id) {
        for (OptistructBaseSettingType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public int getId() {
        return id;
    }

    public int getMaxValue() {
        return maxValue;
    }

    public void setMaxValue(int maxValue) {
        this.maxValue = maxValue;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public int getMinValue() {
        return minValue;
    }

    public void setMinValue(int minValue) {
        this.minValue = minValue;
    }
}
