package ru.crp.lvms.optimizations.tosca.config.argumentConverters;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationTechnologicalConstraint;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNode;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationTechnologicalConstraintManager;

import java.util.Collections;
import java.util.List;
import java.util.Objects;

public class MasterArgumentConverter extends CommandArgumentConverter {
    public static final int MASTER_ARGUMENT_ID = 88;
    public MasterArgumentConverter(ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager) {
        super(toscaOptimizationTechnologicalConstraintManager);
    }


    @Override
    public List<Pair<String, String>> convertValue(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value, List<TechnologicalConstraintTreeNodeValue> allValues, List<Pair<String, String>> alreadyConvertedValues) {
        TechnologicalConstraintTreeNode parent = toscaOptimizationTechnologicalConstraintManager.getField(value.getParentId());
        if (value.getIsValueEditable()) {
            return Collections.singletonList(Pair.of(parent.getName(), String.format("%s, %s", value.getName(), value.getValue())));
        } else {
            return Collections.singletonList(Pair.of(parent.getName(), value.getName()));
        }
    }


    @Override
    public boolean canConvert(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value) {
        return Objects.equals(value.getParentId(), MASTER_ARGUMENT_ID);
    }
}
