package ru.crp.lvms.optimizations.tosca.enums;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum NodeOrElem {
    ELEMENT(1),
    NODE(2),
    NODE_AND_ELEMENT(3),
    NODE_OR_ELEM(4),
    SCALAR(5),
    NONE(6);

    private int id;

    NodeOrElem(int id) {
        this.id = id;
    }

    @Nonnull
    public static NodeOrElem valueOf(int id) {
        for (NodeOrElem cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public int getId() {
        return id;
    }
    public String getName() {
        return this.toString();
    }
}
