package ru.crp.lvms.pdf.reports;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.model.entities.effective.characteristics.ECDefectEntity;
import ru.crp.lvms.model.entities.effective.characteristics.ECParamEntity;

import java.nio.file.Path;
import java.util.Collections;
import java.util.Date;
import java.util.List;

public class ECReportInput {
    private String ecName;
    private Date creationDate;
    private String userName;

    private List<ECParamEntity> mesoParams;
    private List<ECParamEntity> microParams;
    private List<ECDefectEntity> defects;
    private List<Pair<String, String>> ecMicrostructure;
    private List<Pair<String, String>> ecMezostructure;

    private Path pathToMicrostructurePicture;
    private Path pathToMesostructurePicture;

    public ECReportInput() {
        mesoParams = Collections.emptyList();
        microParams = Collections.emptyList();
        defects = Collections.emptyList();
        ecMicrostructure = Collections.emptyList();
        ecMezostructure = Collections.emptyList();
    }

    public String getEcName() {
        return ecName;
    }

    public void setEcName(String ecName) {
        this.ecName = ecName;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public List<ECDefectEntity> getDefects() {
        return defects;
    }

    public void setDefects(List<ECDefectEntity> defects) {
        this.defects = defects;
    }

    public List<Pair<String, String>> getEcMicrostructure() {
        return ecMicrostructure;
    }

    public void setEcMicrostructure(List<Pair<String, String>> ecMicrostructure) {
        this.ecMicrostructure = ecMicrostructure;
    }

    public List<Pair<String, String>> getEcMezostructure() {
        return ecMezostructure;
    }

    public void setEcMezostructure(List<Pair<String, String>> ecMezostructure) {
        this.ecMezostructure = ecMezostructure;
    }

    public Path getPathToMicrostructurePicture() {
        return pathToMicrostructurePicture;
    }

    public void setPathToMicrostructurePicture(Path pathToMicrostructurePicture) {
        this.pathToMicrostructurePicture = pathToMicrostructurePicture;
    }

    public Path getPathToMesostructurePicture() {
        return pathToMesostructurePicture;
    }

    public void setPathToMesostructurePicture(Path pathToMesostructurePicture) {
        this.pathToMesostructurePicture = pathToMesostructurePicture;
    }

    public List<ECParamEntity> getMesoParams() {
        return mesoParams;
    }

    public void setMesoParams(List<ECParamEntity> mesoParams) {
        this.mesoParams = mesoParams;
    }

    public List<ECParamEntity> getMicroParams() {
        return microParams;
    }

    public void setMicroParams(List<ECParamEntity> microParams) {
        this.microParams = microParams;
    }
}
