package ru.crp.lvms.pdf.reports.vo;

import javax.xml.bind.annotation.*;
import java.util.List;

@XmlRootElement(name = "ec")
@XmlSeeAlso({ Parameter.class, SimpleParameter.class, CompositeParameter.class })
@XmlAccessorType(XmlAccessType.FIELD)
public class ReportInnerECParameters {
    private String name;
    private String date;
    private String user;

    private String microPic;
    private String mesoPic;

    @XmlElementWrapper(name = "parammicro")
    @XmlElementRef()
    private List<Parameter> parammicro;

    @XmlElementWrapper(name = "parammeso")
    @XmlElementRef()
    private List<Parameter> parammeso;

    @XmlElementWrapper(name = "defects")
    @XmlElementRef()
    private List<Defect> defects;

    private Integer ecmicroLength;

    @XmlElementWrapper(name = "ecmicro")
    @XmlElementRef()
    private List<SimpleParameter> ecmicro;

    private Integer ecmesoLength;

    @XmlElementWrapper(name = "ecmeso")
    @XmlElementRef()
    private List<SimpleParameter> ecmeso;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getUser() {
        return user;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public List<Parameter> getParammicro() {
        return parammicro;
    }

    public void setParammicro(List<Parameter> parammicro) {
        this.parammicro = parammicro;
    }

    public List<Parameter> getParammeso() {
        return parammeso;
    }

    public void setParammeso(List<Parameter> parammeso) {
        this.parammeso = parammeso;
    }

    public List<Defect> getDefects() {
        return defects;
    }

    public void setDefects(List<Defect> defects) {
        this.defects = defects;
    }

    public Integer getEcmicroLength() {
        return ecmicroLength;
    }

    public List<SimpleParameter> getEcmicro() {
        return ecmicro;
    }

    public void setEcmicro(List<SimpleParameter> ecmicro) {
        this.ecmicroLength = ecmicro.size();
        this.ecmicro = ecmicro;
    }

    public Integer getEcmesoLength() {
        return ecmesoLength;
    }

    public List<SimpleParameter> getEcmeso() {
        return ecmeso;
    }

    public void setEcmeso(List<SimpleParameter> ecmeso) {
        this.ecmesoLength = ecmeso.size();
        this.ecmeso = ecmeso;
    }

    public String getMicroPic() {
        return microPic;
    }

    public void setMicroPic(String microPic) {
        this.microPic = microPic;
    }

    public String getMesoPic() {
        return mesoPic;
    }

    public void setMesoPic(String mesoPic) {
        this.mesoPic = mesoPic;
    }
}

