package ru.crp.lvms.security;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.MessageSource;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.lvms.model.dao.UserDao;
import ru.crp.lvms.model.entities.UserEntity;

import static ru.crp.lvms.utils.MessageUtils.WRONG_LOGIN;

@Component("userDetailsService")
public class UserDetailsService implements org.springframework.security.core.userdetails.UserDetailsService {

    @Autowired
    private UserDao userDao;
    @Autowired
    private MessageSource msgSrc;

    @Transactional(readOnly = true)
    @Override
    public UserDetails loadUserByUsername(String username) {
        UserEntity user = userDao.findByName(username);
        if (user != null) {
            return new PortalUser(username, user.getPassword(), user.isActive(),
                    true, true, true, AuthorityUtils.createAuthorityList(user.getRole().getUname()), user);
        }
        throw new BadCredentialsException(msgSrc.getMessage(WRONG_LOGIN, null, null));
    }
}
