package ru.crp.lvms.tasks;

import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.cmlb.model.entities.CalculationStatus;
import ru.crp.lvms.cluster.model.ClusterEntity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.misc.BaseTasksJob;
import ru.crp.lvms.tasks.misc.ClusterCommandsManager;

import java.util.List;


@Component("startTasksJob")
public class StartTasksJob extends BaseTasksJob {

    @Override
    @Transactional(readOnly = true)
    public List<TaskEntity> getTasksToCheck() {
        return taskDao.getWholeTaskQueue();
    }

    @Override
    public void checkTask(TaskEntity waitingTask, ClusterEntity taskCluster, ClusterCommandsManager clusterCommandManager) throws Exception {
        if (!clusterCommandManager.isTaskReadyForStart(waitingTask, taskCluster)) {
            return;
        }
        // updating task in db to make node busy and don't use it for other tasks
        taskStatusUpdater.changeTaskStatus(waitingTask, CalculationStatus.Sending);
        clusterCommandManager.startTask(waitingTask);
    }
}
