package ru.crp.lvms.tasks.fileGenerators;

import org.apache.commons.lang3.StringUtils;

public class TSParameters {
    private String minRadius;
    private String numLevels;
    private String verticalStep;

    private String lineFeedRate;
    private String lineExtrusionRate;
    private String arcFeedRate;

    private String arcExtrusionRate;

    private String printRectMinX;
    private String printRectMinY;

    private String printRectMaxX;
    private String printRectMaxY;

    private String usefulRectMinX;
    private String usefulRectMinY;
    private String usefulRectMaxX;
    private String usefulRectMaxY;

    private String originX;
    private String originY;

    private String angle;
    private String steps;

    private final static String thread_width = "1.5";

    public String getMinRadius() {
        return minRadius;
    }

    public void setMinRadius(String minRadius) {
        this.minRadius = minRadius;
    }

    public String getNumLevels() {
        return numLevels;
    }

    public void setNumLevels(String numLevels) {
        this.numLevels = numLevels;
    }

    public String getVerticalStep() {
        return verticalStep;
    }

    public void setVerticalStep(String verticalStep) {
        this.verticalStep = verticalStep;
    }

    public String getLineFeedRate() {
        return lineFeedRate;
    }

    public void setLineFeedRate(String lineFeedRate) {
        this.lineFeedRate = lineFeedRate;
    }

    public String getLineExtrusionRate() {
        return lineExtrusionRate;
    }

    public void setLineExtrusionRate(String lineExtrusionRate) {
        this.lineExtrusionRate = lineExtrusionRate;
    }

    public String getArcFeedRate() {
        return arcFeedRate;
    }

    public void setArcFeedRate(String arcFeedRate) {
        this.arcFeedRate = arcFeedRate;
    }

    public String getArcExtrusionRate() {
        return arcExtrusionRate;
    }

    public void setArcExtrusionRate(String arcExtrusionRate) {
        this.arcExtrusionRate = arcExtrusionRate;
    }

    public String getPrintRectMinX() {
        return printRectMinX;
    }

    public void setPrintRectMinX(String printRectMinX) {
        this.printRectMinX = printRectMinX;
    }

    public String getPrintRectMinY() {
        return printRectMinY;
    }

    public void setPrintRectMinY(String printRectMinY) {
        this.printRectMinY = printRectMinY;
    }

    public String getPrintRectMaxX() {
        return printRectMaxX;
    }

    public void setPrintRectMaxX(String printRectMaxX) {
        this.printRectMaxX = printRectMaxX;
    }

    public String getPrintRectMaxY() {
        return printRectMaxY;
    }

    public void setPrintRectMaxY(String printRectMaxY) {
        this.printRectMaxY = printRectMaxY;
    }

    public String getUsefulRectMinX() {
        return usefulRectMinX;
    }

    public void setUsefulRectMinX(String usefulRectMinX) {
        this.usefulRectMinX = usefulRectMinX;
    }

    public String getUsefulRectMinY() {
        return usefulRectMinY;
    }

    public void setUsefulRectMinY(String usefulRectMinY) {
        this.usefulRectMinY = usefulRectMinY;
    }

    public String getUsefulRectMaxX() {
        return usefulRectMaxX;
    }

    public void setUsefulRectMaxX(String usefulRectMaxX) {
        this.usefulRectMaxX = usefulRectMaxX;
    }

    public String getUsefulRectMaxY() {
        return usefulRectMaxY;
    }

    public void setUsefulRectMaxY(String usefulRectMaxY) {
        this.usefulRectMaxY = usefulRectMaxY;
    }

    public String getOriginX() {
        return originX;
    }

    public void setOriginX(String originX) {
        this.originX = originX;
    }

    public String getOriginY() {
        return originY;
    }

    public void setOriginY(String originY) {
        this.originY = originY;
    }

    public String getAngle() {
        return angle;
    }

    public void setAngle(String angle) {
        this.angle = angle;
    }

    public String getSteps() {
        return steps;
    }

    public void setSteps(String steps) {
        this.steps = steps;
    }

    public static String getThread_width() {
        return thread_width;
    }



    //    public boolean isAllParametersPresent() {
//        return isAllParametersPresent();
//    }


    @Override
    public String toString() {
        return "TSParameters{" +
                "minRadius='" + minRadius + '\'' +
                ", numLevels='" + numLevels + '\'' +
                ", verticalStep='" + verticalStep + '\'' +
                ", lineFeedRate='" + lineFeedRate + '\'' +
                ", lineExtrusionRate='" + lineExtrusionRate + '\'' +
                ", arcFeedRate='" + arcFeedRate + '\'' +
                ", arcExtrusionRate='" + arcExtrusionRate + '\'' +
                ", printRectMinX='" + printRectMinX + '\'' +
                ", printRectMinY='" + printRectMinY + '\'' +
                ", printRectMaxX='" + printRectMaxX + '\'' +
                ", printRectMaxY='" + printRectMaxY + '\'' +
                ", usefulRectMinX='" + usefulRectMinX + '\'' +
                ", usefulRectMinY='" + usefulRectMinY + '\'' +
                ", usefulRectMaxX='" + usefulRectMaxX + '\'' +
                ", usefulRectMaxY='" + usefulRectMaxY + '\'' +
                '}';
    }


    public String tsParamToJson() {
        return "{\n" +
                "\"min_radius\":" + minRadius + ",\n" +
                "\"num_levels\":" + numLevels + ",\n" +
                "\"thread_width\":" + thread_width + ",\n" +
                "\"vertical_step\":" + verticalStep + ",\n" +
                "\"line_feed_rate\":" + lineFeedRate + ",\n" +
                "\"line_extrusion_rate\":" + lineExtrusionRate + ",\n" +
                "\"arc_feed_rate\":" + arcFeedRate + ",\n" +
                "\"arc_extrusion_rate\":" + arcExtrusionRate + ",\n" +
                "\"print_rect\":"+ "\n" +
                "{"+ "\n" +
                "\"min\":" + " ["+ printRectMinX + "," + printRectMinY + "] ,\n"+
                "\"max\":" + " ["+ printRectMaxX + "," + printRectMaxY + "] \n"+
                "}"+ ",\n" +
                "\"useful_rect\":"+ "\n" +
                "{"+ "\n" +
                "\"min\":" + " ["+ usefulRectMinX + "," + usefulRectMinY + "] ,\n"+
                "\"max\":" + " ["+ usefulRectMaxX + "," + usefulRectMaxY + "] \n"+
                "}"+ ",\n" ;
    }
}
