package ru.crp.lvms.tasks.fileGenerators;


import org.apache.commons.lang3.StringUtils;

public class ThermalSimulationParameters {
    private String fiberThermalConductivity;
    private String matrixThermalConductivity;
    private String epoxideThermalConductivity;
    private String fiberLinearThermalExpansion;
    private String matrixLinearThermalExpansion;
    private String epoxideLinearThermalExpansion;
    private boolean isEpoxidePresent;

    public String getFiberThermalConductivity() {
        return fiberThermalConductivity;
    }

    public String getMatrixThermalConductivity() {
        return matrixThermalConductivity;
    }

    public String getEpoxideThermalConductivity() {
        return epoxideThermalConductivity;
    }

    public String getFiberLinearThermalExpansion() {
        return fiberLinearThermalExpansion;
    }

    public String getMatrixLinearThermalExpansion() {
        return matrixLinearThermalExpansion;
    }

    public String getEpoxideLinearThermalExpansion() {
        return epoxideLinearThermalExpansion;
    }

    public void setFiberThermalConductivity(String fiberThermalConductivity) {
        this.fiberThermalConductivity = fiberThermalConductivity;
    }

    public void setMatrixThermalConductivity(String matrixThermalConductivity) {
        this.matrixThermalConductivity = matrixThermalConductivity;
    }

    public void setEpoxideThermalConductivity(String epoxideThermalConductivity) {
        this.epoxideThermalConductivity = epoxideThermalConductivity;
    }

    public void setFiberLinearThermalExpansion(String fiberLinearThermalExpansion) {
        this.fiberLinearThermalExpansion = fiberLinearThermalExpansion;
    }

    public void setMatrixLinearThermalExpansion(String matrixLinearThermalExpansion) {
        this.matrixLinearThermalExpansion = matrixLinearThermalExpansion;
    }

    public void setEpoxideLinearThermalExpansion(String epoxideLinearThermalExpansion) {
        this.epoxideLinearThermalExpansion = epoxideLinearThermalExpansion;
    }

    public boolean isAllParametersPresent() {
        return isMatrixParametersPresent() && isFiberParametersPresent() && (!isEpoxidePresent || isEpoxideParametersPresent());
    }

    public boolean isMatrixParametersPresent() {
        return !StringUtils.trimToEmpty(matrixLinearThermalExpansion).isEmpty() &&
                !StringUtils.trimToEmpty(matrixThermalConductivity).isEmpty();
    }

    public boolean isFiberParametersPresent() {
        return !StringUtils.trimToEmpty(fiberLinearThermalExpansion).isEmpty() &&
                !StringUtils.trimToEmpty(fiberThermalConductivity).isEmpty();
    }

    public boolean isEpoxideParametersPresent() {
        return !StringUtils.trimToEmpty(epoxideLinearThermalExpansion).isEmpty() &&
                !StringUtils.trimToEmpty(epoxideThermalConductivity).isEmpty();
    }

    public boolean isEpoxidePresent() {
        return isEpoxidePresent;
    }

    public void setEpoxidePresent(boolean isEpoxidePresent) {
        this.isEpoxidePresent = isEpoxidePresent;
    }

}
