package ru.crp.lvms.tasks.misc;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

import javax.annotation.Nullable;
import javax.validation.constraints.NotNull;
import java.nio.file.Path;

@Table("task_custom_files")
public class TaskCustomFile implements Entity {
    private int id;

    @Column("file_name")
    private String name;

    @Column("task_id")
    private int taskId;

    @NotNull(message = "File id must not be empty")
    @Column("path_to_file")
    // when come from client contain not path but file id
    private String path;

    public static TaskCustomFile fromPath(Path baseDir, Path path) {
        return new TaskCustomFile(path.getFileName().toString(), baseDir.relativize(path).toString());
    }

    // is used for mapping
    public TaskCustomFile() {
    }

    public TaskCustomFile(String name, String path) {
        this.name = name;
        this.path = path;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public int getTaskId() {
        return taskId;
    }

    public void setTaskId(int taskId) {
        this.taskId = taskId;
    }

    @Override
    public boolean equals(@Nullable Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TaskCustomFile that = (TaskCustomFile) o;

        if (id != that.id) return false;
        if (taskId != that.taskId) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        return !(path != null ? !path.equals(that.path) : that.path != null);

    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + taskId;
        result = 31 * result + (path != null ? path.hashCode() : 0);
        return result;
    }
}
