package ru.crp.lvms.tasks.slurm;


import org.springframework.stereotype.Service;
import ru.crp.lvms.cluster.model.SlurmClusterConfigEntity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;

@Service
//todo use static variables from ConfigData instead of hardcoded strings
public class SlurmPathsResolver {
    public static final String STDOUT_FILE_NAME = "slurm.out";
    public static final String STDERR_FILE_NAME = "slurm.err";


    public String getWorkDirForTask(SlurmClusterConfigEntity config, TaskEntity task) {
        return String.format("%ssim-%d-task-%d", config.getAllResultsDir(), task.getParentId(), task.getId());
    }

    public String getInputDirForTask(SlurmClusterConfigEntity config, TaskEntity task) {
        return getWorkDirForTask(config, task);
    }

    public String getOutputDirForTask(SlurmClusterConfigEntity config, TaskEntity task) {
        return getWorkDirForTask(config, task);
    }

    public String getPathToStdOutFileForTask(SlurmClusterConfigEntity clusterConfig, TaskEntity task) {
        return getWorkDirForTask(clusterConfig, task) + "/" + STDOUT_FILE_NAME;
    }
}
