package ru.crp.lvms.utils;

import org.springframework.security.access.AccessDeniedException;
import ru.crp.lvms.model.entities.UserEntity;
import ru.crp.lvms.web.dto.user.UserRole;

public final class AuthUtils {
    private AuthUtils() {

    }

    public static void ownerOrGreaterOrAdmin(UserEntity ownerUser, UserEntity currentUser) {
        if (currentUser.getId() == ownerUser.getId() ||
                currentUser.getRole().getPriority() > ownerUser.getRole().getPriority() ||
                currentUser.getRole().equals(UserRole.Administrator)) return;
        else throw new AccessDeniedException("You have no rights to apply this action");
    }

    public static boolean isOwnerOrAdmin(int ownerId, UserEntity currentUser) {
        return currentUser.getId() == ownerId || currentUser.getRole().equals(UserRole.Administrator);
    }

    public static void ownerOrAdmin(int ownerId, UserEntity currentUser) {
        if (currentUser.getId() == ownerId || currentUser.getRole().equals(UserRole.Administrator)) {
            return;
        }
        throw new AccessDeniedException("Недостаточно прав для совершения данного действия");
    }
}
