package ru.crp.lvms.validators;

import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.dao.*;
import ru.crp.lvms.model.dao.construction.elements.ConstructionElementDao;
import ru.crp.lvms.model.dao.effective.characteristics.ECDao;
import ru.crp.lvms.model.dao.simulations.SimulationDao;
import ru.crp.lvms.model.entities.*;
import ru.crp.lvms.model.entities.compositeMaterials.CompositeMaterialEntity;
import ru.crp.lvms.model.entities.construction.elements.ConstructionElementEntity;
import ru.crp.lvms.model.entities.effective.characteristics.ECEntity;
import ru.crp.lvms.model.entities.simulations.SimulationEntity;
import ru.crp.lvms.model.entities.technology.TechnologyEntity;
import ru.crp.lvms.model.entities.tree.DefectNameEntity;
import ru.crp.lvms.model.entities.tree.TreeNode;
import ru.crp.lvms.optimizations.base.dao.OptimizationDao;
import ru.crp.lvms.optimizations.base.dao.OptimizationTypeDao;
import ru.crp.lvms.optimizations.base.entities.OptimizationEntity;
import ru.crp.lvms.optimizations.base.entities.OptimizationType;

import java.util.HashMap;
import java.util.Map;

public class BaseEntityValidator {
    @Autowired
    private FileDao fileDao;

    @Autowired
    private MaterialDao materialDao;

    @Autowired
    private TreeDao treeDao;

    @Autowired
    private TechnologyDao technologyDao;

    @Autowired
    private CompositeMaterialDao compositeMaterialDao;

    @Autowired
    private ParametersDao parametersDao;

    @Autowired
    private EquipmentDao equipmentDao;

    @Autowired
    private StandardDao standardDao;

    @Autowired
    private OptimizationTypeDao optimizationTypeDao;

    @Autowired
    private UserDao userDao;

    @Autowired
    private ConstructionElementDao constructionElementDao;

    @Autowired
    private DefectNameDao defectNameDao;

    @Autowired
    private ECDao ECDao;

    @Autowired
    private SimulationDao simulationDao;

    @Autowired
    private OptimizationDao optimizationDao;

    protected Map<Class<?>, BaseSpaceDao<? extends Entity>> daoList;

    protected Class<?> entityClass;

    protected void init(Class<?> entityClass) {
        daoList = new HashMap<>();
        daoList.put(FileEntity.class, fileDao);
        daoList.put(MaterialEntity.class, materialDao);
        daoList.put(TreeNode.class, treeDao);
        daoList.put(TechnologyEntity.class, technologyDao);
        daoList.put(EquipmentEntity.class, equipmentDao);
        daoList.put(CompositeMaterialEntity.class, compositeMaterialDao);
        daoList.put(ParametersEntityTable.class, parametersDao);
        daoList.put(StandardEntity.class, standardDao);
        daoList.put(OptimizationType.class, optimizationTypeDao);
        daoList.put(UserEntity.class, userDao);
        daoList.put(ConstructionElementEntity.class, constructionElementDao);
        daoList.put(DefectNameEntity.class, defectNameDao);
        daoList.put(ECEntity.class, ECDao);
        daoList.put(SimulationEntity.class, simulationDao);
        daoList.put(OptimizationEntity.class, optimizationDao);

        this.entityClass = entityClass;
    }
}
