package ru.crp.lvms.validators;

import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.dao.BaseSpaceDao;

import javax.annotation.Nullable;
import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

public class EntityExistsValidator extends BaseEntityValidator implements ConstraintValidator<EntityExists, Integer> {

    @Override
    public void initialize(EntityExists constraintAnnotation) {
        init(constraintAnnotation.entityClass());
    }

    @Override
    public boolean isValid(@Nullable Integer id, ConstraintValidatorContext context) {
        if (id == null) {
            return true;
        }
        BaseSpaceDao<? extends Entity> dao = daoList.get(entityClass);
        if (dao == null) {
            throw new IllegalStateException("Can't validate because No dao found for class " + entityClass);
        }
        return dao.findOne(id) != null;
    }
}
