package ru.crp.lvms.validators;

import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.managers.EquipmentManager;
import ru.crp.lvms.web.dto.CompositeMaterialIn;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

public class EquipmentBelongsTechnologyValidator
        implements ConstraintValidator<EquipmentBelongsTechnology, CompositeMaterialIn> {

    @Autowired
    private EquipmentManager equipmentManager;

    @Override
    public void initialize(EquipmentBelongsTechnology constraintAnnotation) {

    }

    @Override
    public boolean isValid(CompositeMaterialIn material, ConstraintValidatorContext context) {
        Integer technologyId = material.getTechnologyId();
        Integer equipmentId = material.getEquipmentId();
        if (technologyId == null && equipmentId == null) {
            return true;
        }
        if (equipmentId == null) {
            return true;
        }
        if (technologyId == null) {
            return false;
        }
        return equipmentManager.isEquipmentBelongsToTechnology(equipmentId, technologyId);
    }
}
