package ru.crp.lvms.web.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.cluster.ClustersManager;
import ru.crp.lvms.cluster.model.ClusterInfo;
import ru.crp.lvms.model.SuggestDTO;

import java.util.Comparator;
import java.util.List;

import static java.util.stream.Collectors.toList;

@RestController
@RequestMapping("")
public class ClustersController {
    @Autowired
    private ClustersManager clustersManager;

    @PreAuthorize("hasRole('ROLE_USER')")
    @RequestMapping(value = "/clustersInfo")
    public List<ClusterInfo> getClustersInfo() {
        return clustersManager.getFreshClustersInfo();
    }


    @RequestMapping(value = "/clusters", method = RequestMethod.GET)
    public List<SuggestDTO> getClustersForSuggest() {
        return clustersManager.getAllClusters().stream()
                .map(SuggestDTO::new)
                .sorted(Comparator.comparing(SuggestDTO::getText))
                .collect(toList());
    }
}
