package ru.crp.lvms.web.controllers;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.exceptions.BadRequestException;
import ru.crp.lvms.managers.ReferenceGraphManager;
import ru.crp.lvms.model.entities.ReferenceGraphEntry;

@RestController
@RequestMapping(value = "/referenceGraph", produces = MediaType.APPLICATION_JSON_VALUE)
public class ReferenceGraphController {
    private static final String FORBIDDEN_ITEM_TYPE_ERROR_MESSAGE = "No reference graph for type ";

    @Autowired
    private ReferenceGraphManager referenceGraphManager;


    @RequestMapping(method = RequestMethod.GET)
    public ReferenceGraphEntry getReferenceGraph(@RequestParam("id") Integer entranceId,
                                                 @RequestParam("type") String type) throws BadRequestException {
        if (!referenceGraphManager.hasRelationGraph(type)) {
            throw new BadRequestException(FORBIDDEN_ITEM_TYPE_ERROR_MESSAGE + type);
        }
        return referenceGraphManager.getReferenceGraph(entranceId, type);
    }
}
