package ru.crp.lvms.web.controllers.technology;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.cmlb.model.SuggestRequest;
import ru.crp.lvms.managers.misc.PreferencesManager;
import ru.crp.lvms.model.dao.DefectNameDao;
import ru.crp.lvms.model.entities.PossibleDefectsEntity;
import ru.crp.lvms.model.entities.tree.DefectNameEntity;
import ru.crp.lvms.security.CurrentUser;
import ru.crp.lvms.security.PortalUser;
import ru.crp.lvms.web.controllers.misc.ColumnsController;

import javax.validation.Valid;
import java.util.List;

import static ru.crp.lvms.utils.URLs.TECHNOLOGY_URL;

@Transactional(isolation = Isolation.SERIALIZABLE)
@RestController
@RequestMapping(value = TECHNOLOGY_URL + "/defects", produces = MediaType.APPLICATION_JSON_VALUE)
public class PossibleDefectsController implements ColumnsController {
    @Autowired
    private PreferencesManager preferencesManager;

    @Autowired
    private DefectNameDao defectNameDao;

    @RequestMapping(value = "/suggest", method = RequestMethod.POST)
    public List<DefectNameEntity> suggest(@RequestBody @Valid SuggestRequest suggestRequest,
                                          @CurrentUser PortalUser currentUser) {
        return defectNameDao.suggest(suggestRequest, currentUser.getUser().getId());
    }

    @Override
    public Class getOutVoClass() {
        return PossibleDefectsEntity.class;
    }

    @Override
    public PreferencesManager getPreferencesManager() {
        return preferencesManager;
    }
}
