package ru.crp.lvms.web.dto;

import ru.crp.lvms.model.entities.compositeMaterials.CompositeMaterialEntity;
import ru.crp.lvms.model.entities.EquipmentEntity;
import ru.crp.lvms.model.entities.MaterialEntity;
import ru.crp.lvms.model.entities.technology.TechnologyEntity;
import ru.crp.lvms.validators.EntityExists;
import ru.crp.lvms.validators.EquipmentBelongsTechnology;
import ru.crp.lvms.validators.Unique;

@Unique(entityClass = CompositeMaterialEntity.class, fieldName = "name", columnNane = "name",
        message = "Имя должно быть уникально")
@EquipmentBelongsTechnology
public class CompositeMaterialIn extends MaterialIn {
    @EntityExists(entityClass = TechnologyEntity.class, message = "Технология не найдена")
    private Integer technologyId;

    @EntityExists(entityClass = EquipmentEntity.class, message = "Оборудование не найдено")
    private Integer equipmentId;

    @EntityExists(entityClass = MaterialEntity.class, message = "Материал волокна не найден")
    private Integer fiberId;

    @EntityExists(entityClass = MaterialEntity.class, message = "Материал матрицы не найден")
    private Integer matrixId;

    private Double fiberConcentration;

    private boolean symmetricalLayers;

    @EntityExists(entityClass = MaterialEntity.class, message = "Материал эпоксида не найден")
    private Integer epoxideId;

    public Integer getTechnologyId() {
        return technologyId;
    }

    public void setTechnologyId(Integer technologyId) {
        this.technologyId = technologyId;
    }

    public Integer getEquipmentId() {
        return equipmentId;
    }

    public void setEquipmentId(Integer equipmentId) {
        this.equipmentId = equipmentId;
    }

    public boolean isSymmetricalLayers() {
        return symmetricalLayers;
    }

    public void setSymmetricalLayers(boolean symmetricalLayers) {
        this.symmetricalLayers = symmetricalLayers;
    }

    public Integer getFiberId() {
        return fiberId;
    }

    public void setFiberId(Integer fiberId) {
        this.fiberId = fiberId;
    }

    public Integer getMatrixId() {
        return matrixId;
    }

    public void setMatrixId(Integer matrixId) {
        this.matrixId = matrixId;
    }

    public Double getFiberConcentration() {
        return fiberConcentration;
    }

    public void setFiberConcentration(Double fiberConcentration) {
        this.fiberConcentration = fiberConcentration;
    }

    public Integer getEpoxideId() {
        return epoxideId;
    }

    public void setEpoxideId(Integer epoxideId) {
        this.epoxideId = epoxideId;
    }
}
