package ru.crp.lvms.web.dto.user;

import ru.crp.cmlb.model.entities.Suggest;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;
import ru.crp.lvms.web.dto.misc.ValueObject;

import java.util.Date;

public class UserOut extends ValueObject {

    private int id;
    @GridColumn(name = "login", label = "Логин", editable = false, order = 1)
    private String login;
    @GridColumn(name = "email", label = "E-mail", order = 2, cell = GridColumnType.email)
    private String email;
    @Suggest()
    @GridColumn(name = "name", label = "Имя", order = 0, cell = GridColumnType.uri)
    private String name;
    @GridColumn(name = "phone", label = "Телефон", order = 3)
    private String phone;
    private boolean active;
    private boolean notified;
    private String role;
    @GridColumn(name = "roleDisplayName", label = "Роль", order = 4)
    private String roleDisplayName;
    private int roleId;
    @GridColumn(name = "creationDate", label = "Дата создания", cell = GridColumnType.date, order = 6)
    private Date creationDate;
    @GridColumn(name = "birthDate", label = "Дата рождения", cell = GridColumnType.date, order = 5)
    private Date birthDate;

    public Date getCreationDate() {
        return creationDate != null ? new Date(creationDate.getTime()) : null;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate != null ? new Date(creationDate.getTime()) : null;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    public boolean isNotified() {
        return notified;
    }

    public void setNotified(boolean notified) {
        this.notified = notified;
    }

    public int getRoleId() {
        return roleId;
    }

    public void setRoleId(int roleId) {
        this.roleId = roleId;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    public Date getBirthDate() {
        return birthDate != null ? new Date(birthDate.getTime()) : null;
    }

    public void setBirthDate(Date birthDate) {
        this.birthDate = birthDate != null ? new Date(birthDate.getTime()) : null;
    }

    public String getRoleDisplayName() {
        return roleDisplayName;
    }

    public void setRoleDisplayName(String roleDisplayName) {
        this.roleDisplayName = roleDisplayName;
    }
}
