ALTER TABLE optimization_type_solver_combinations
  ADD CONSTRAINT unique_solvers_combination UNIQUE (cao_id, cae_id, cad_id, optimization_type_id);

-- ModFrontier - Ansys - Solidworks
UPDATE optimization_type_solver_combinations
SET available = TRUE
WHERE cao_id = 2 AND cae_id = 1 AND cad_id = 1;

-- ModFrontier - Abaqus - Solidworks
INSERT INTO optimization_type_solver_combinations (cao_id, cae_id, cad_id, optimization_type_id, available)
VALUES (2, 2, 1, 4, 'TRUE');

-- ModFrontier - Abaqus
INSERT INTO optimization_type_solver_combinations (cao_id, cae_id, cad_id, optimization_type_id, available)
VALUES (2, 2, null, 4, 'TRUE');

INSERT INTO optimization_base_setting_types (id, max_value, display_name)
VALUES (5, 8, 'Количество варьируемых CAD параметров');

UPDATE optimization_base_setting_types SET display_name = 'Количество варьируемых CAO параметров' WHERE id = 2;

CREATE TABLE optimization_cad_varying_params (
  id                SERIAL,
  optimization_id   INTEGER NOT NULL,
  name              VARCHAR(255),
  lower_bound       DOUBLE PRECISION,
  upper_bound       DOUBLE PRECISION,
  sampling          INTEGER,

  PRIMARY KEY (id),
  FOREIGN KEY (optimization_id) REFERENCES optimizations (id) ON DELETE CASCADE
);
CREATE INDEX ON optimization_cad_varying_params (optimization_id);
