ALTER TABLE optistruct_optimization_load_steps RENAME TO optistruct_optimization_collectors;

CREATE TABLE optistruct_optimization_load_steps (
  id SERIAL,
  script_id INTEGER NOT NULL,
  optimization_id INTEGER NOT NULL,

  name VARCHAR(255) NOT NULL,
  is_fixed BOOLEAN NOT NULL,
  selected_load_ids INTEGER[],
  calculation_type VARCHAR(255) NOT NULL,

  FOREIGN KEY(optimization_id) REFERENCES optimizations(id) ON DELETE CASCADE,
  PRIMARY KEY(id)
);

INSERT INTO optistruct_optimization_base_setting_types (id, min_value, max_value, display_name) VALUES
 (5, 1, 8, 'Количество шагов нагружения');

CREATE VIEW optistruct_optimization_load_steps_join AS (
  SELECT
    base.*,
    o.optimization_type_id           AS optimization_type_id

  FROM optistruct_optimization_load_steps base
    JOIN optimizations o ON base.optimization_id = o.id
);

CREATE RULE optistruct_optimization_load_steps_join_CREATE
AS ON INSERT TO optistruct_optimization_load_steps_join DO INSTEAD (
  INSERT INTO optistruct_optimization_load_steps (script_id, optimization_id, name,
   is_fixed, selected_load_ids, calculation_type)
  VALUES (NEW.script_id, NEW.optimization_id, NEW.name,
   NEW.is_fixed, NEW.selected_load_ids, NEW.calculation_type)
  RETURNING
    optistruct_optimization_load_steps.*,
    NULL :: INTEGER AS optimization_type_id
);

CREATE RULE optistruct_optimization_load_steps_join_UPDATE
AS ON UPDATE TO optistruct_optimization_load_steps_join DO INSTEAD (
  UPDATE optistruct_optimization_load_steps
  SET name = NEW.name, is_fixed = NEW.is_fixed, selected_load_ids = NEW.selected_load_ids,
   calculation_type = NEW.calculation_type
  WHERE id = NEW.id);

CREATE RULE optistruct_optimization_load_steps_join_DELETE
AS ON DELETE TO optistruct_optimization_load_steps_join DO INSTEAD (
  DELETE FROM optistruct_optimization_tech_constraints
  WHERE id = OLD.id
);
