ALTER TABLE technologies ADD COLUMN description VARCHAR;

DROP VIEW technologies_join;

CREATE VIEW technologies_join AS
  SELECT
    tech.*,
    descr.name         AS descr_name,
    descr.path_to_file AS descr_source,
    image.name         AS image_name,
    image.path_to_file AS image_source
  FROM technologies tech
    LEFT OUTER JOIN files descr
      ON tech.description_file_id = descr.id
    LEFT OUTER JOIN files image
      ON tech.image_file_id = image.id;