--Security roles. Id is not generated because roles is predefined
CREATE TABLE roles (
  id       INTEGER,
  uname    VARCHAR UNIQUE              NOT NULL,
  name     VARCHAR                     NOT NULL,
  priority INTEGER DEFAULT 0,

  PRIMARY KEY (id)
);


INSERT INTO roles (id, uname, name, priority) VALUES
  (3, 'ROLE_ADMIN', 'Administrator', 300),
  (2, 'ROLE_USER', 'User', 100),
  (1, 'ROLE_GUEST', 'Guest', 0);


CREATE TABLE persistent_logins (
  username  VARCHAR   NOT NULL,
  series    VARCHAR PRIMARY KEY,
  token     VARCHAR   NOT NULL,
  last_used TIMESTAMP NOT NULL DEFAULT now()
);
--#


-- User profiles
CREATE TABLE users (
  id           SERIAL,
  login        VARCHAR UNIQUE                            NOT NULL,
  name         VARCHAR                                   NOT NULL,
  password     VARCHAR                                   NOT NULL,
  email        VARCHAR                                   NOT NULL,
  phone        VARCHAR,
  active       BOOLEAN DEFAULT TRUE                      NOT NULL,
  notified     BOOLEAN DEFAULT TRUE                      NOT NULL,
  date_created TIMESTAMP WITHOUT TIME ZONE DEFAULT now() NOT NULL,
  role_id      INTEGER                                   NOT NULL,
  birth_date   TIMESTAMP WITHOUT TIME ZONE,
  deleted_at   TIMESTAMP WITHOUT TIME ZONE DEFAULT NULL,

  PRIMARY KEY (id),
  FOREIGN KEY (role_id) REFERENCES roles (id)
);


CREATE VIEW users_join AS
  SELECT
    o.*,
    roles.name AS role
  FROM users o
    JOIN roles ON o.role_id = roles.id;
