ALTER TABLE effective_characteristics ADD COLUMN status_id INTEGER NOT NULL REFERENCES virtual_simulation_statuses(id) DEFAULT 1;

DROP VIEW effective_characteristics_join;

CREATE VIEW effective_characteristics_join AS (
  SELECT ec.*,
  u.name AS owner,
  cm.name AS composite_material_name,
  mf.name AS microstructure_file_name

  FROM effective_characteristics ec
  JOIN users u ON u.id = ec.owner_id
  JOIN composite_materials cm ON cm.id = ec.composite_material_id
  LEFT JOIN files mf ON mf.id = ec.microstructure_file_id
);