CREATE TABLE parameters_dictionary_type (
  id SERIAL,
  name VARCHAR(255),

  PRIMARY KEY(id)
);

INSERT INTO parameters_dictionary_type (id, name) VALUES
  (1, 'TargetFunction'),
  (2, 'Constraint'),
  (3, 'OptimizationMethod'),
  (4, 'DoEType');

CREATE TABLE parameters_dictionary (
  id SERIAL,
  name VARCHAR(255),
  type_id INTEGER NOT NULL,

  PRIMARY KEY(id),
  FOREIGN KEY(type_id) REFERENCES parameters_dictionary_type(id) ON DELETE CASCADE
);

INSERT INTO parameters_dictionary (name, type_id) VALUES ('NONE', 1), ('MIN', 1), ('MAX', 1);

INSERT INTO parameters_dictionary (name, type_id) VALUES ('NONE', 2), ('<', 2), ('>', 2);

INSERT INTO parameters_dictionary (name, type_id) VALUES ('SIMPLEX', 3), ('MOGA-II', 3), ('DOE Sequence', 3);

INSERT INTO parameters_dictionary (name, type_id) VALUES ('Random', 4), ('Sobol', 4), ('Uniform Latin Hypercube', 4);

CREATE VIEW parameters_dictionary_join AS (
  SELECT pd.*,
   pdt.name AS type_name

  FROM parameters_dictionary AS pd
  JOIN parameters_dictionary_type AS pdt ON   pd.type_id = pdt.id
);
