-- previous version doesn't contain 'total_load_conditions' column
CREATE VIEW optimization_flow_join AS (
  SELECT
    o.id as optimization_id,
    (SELECT COUNT(*) FROM tasks t WHERE t.optimization_id = o.id) AS total_tasks,
    (SELECT COUNT(*) FROM optimization_reports opr WHERE opr.optimization_id = o.id) AS total_reports,
    (SELECT COUNT(*) FROM optimization_files opf JOIN files f ON opf.file_id = f.id WHERE opf.optimization_id = o.id AND f.file_type_id IN (8, 9, 10)) AS total_models, -- CAD, CAE and CAO files
    (SELECT COUNT(*) FROM optimization_materials om WHERE om.optimization_id = o.id) AS total_materials,
    (SELECT COUNT(*) FROM optimization_technologies ot WHERE ot.optimization_id = o.id) AS total_technologies,
    (SELECT COUNT(*) FROM optimization_files opf JOIN files f ON opf.file_id = f.id WHERE opf.optimization_id = o.id AND f.file_type_id IN (12)) AS total_load_conditions

  FROM optimizations o
);

CREATE VIEW optimization_flow_results_join AS (
  SELECT
    r.optimization_id,
    r.type,
    SUM(CASE WHEN created_by = 'Manual' THEN 1 ELSE 0 END) total_manual,
    SUM(CASE WHEN created_by = 'Auto' THEN 1 ELSE 0 END) total_auto

  FROM results r
  GROUP BY r.optimization_id, r.type
);
