CREATE TABLE folders (
  id         INTEGER DEFAULT nextval('tree_seq' :: REGCLASS),
  pid        INTEGER,
  tree_type  tree_type  NOT NULL,
  name       VARCHAR    NOT NULL,
  path       VARCHAR [] NOT NULL,
  path_names VARCHAR    NOT NULL,

  PRIMARY KEY (id),
  FOREIGN KEY (pid) REFERENCES folders (id),
  CONSTRAINT unique_path_in_tree UNIQUE (tree_type, path_names)
);


CREATE TRIGGER folders_tree_path_creation
BEFORE INSERT ON folders
FOR EACH ROW
EXECUTE PROCEDURE create_path('Folder');


CREATE TRIGGER folders_path_update
BEFORE UPDATE ON folders
FOR EACH ROW
WHEN (OLD.name IS DISTINCT FROM NEW.name OR OLD.pid IS DISTINCT FROM NEW.pid)
EXECUTE PROCEDURE update_path('Folder');
