' NX 8.0.1.5
' Journal created by novokshenov on Wed Jul 12 15:56:56 2017 Arabian Standard Time
'
Option Strict Off
Imports System
Imports NXOpen

Module NXJournal
Sub Main

Dim theSession As Session = Session.GetSession()
' ----------------------------------------------
'   Menu: File->New...
' ----------------------------------------------
Dim markId1 As Session.UndoMarkId
markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Start")

Dim fileNew1 As FileNew
fileNew1 = theSession.Parts.FileNew()

theSession.SetUndoMarkName(markId1, "##84New Dialog")

Dim markId2 As Session.UndoMarkId
markId2 = theSession.SetUndoMark(Session.MarkVisibility.Invisible, "##84New")

fileNew1.TemplateFileName = "model-plain-1-mm-template.prt"

fileNew1.Application = FileNewApplication.Modeling

fileNew1.Units = Part.Units.Millimeters

fileNew1.TemplateType = FileNewTemplateType.Item

fileNew1.NewFileName = "${tempModelPath}"
<#--EXAMPLE: fileNew1.NewFileName = "${tempmodelpath}E:\Work\Novokshenov\CML\FCP\ISKPI\Nastran_testing\model1.prt"-->

fileNew1.MasterFileName = ""

fileNew1.UseBlankTemplate = False

fileNew1.MakeDisplayedPart = True

Dim nXObject1 As NXObject
nXObject1 = fileNew1.Commit()

Dim workPart As Part = theSession.Parts.Work

Dim displayPart As Part = theSession.Parts.Display

theSession.DeleteUndoMark(markId2, Nothing)

fileNew1.Destroy()

Dim markId3 As Session.UndoMarkId
markId3 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Enter Modeling")

' ----------------------------------------------
'   Menu: File->Import->Simulation...
' ----------------------------------------------
' ----------------------------------------------
'   Dialog Begin Import Simulation
' ----------------------------------------------
Dim partLoadStatus1 As PartLoadStatus
Dim status1 As PartCollection.SdpsStatus
status1 = theSession.Parts.SetDisplay(workPart, False, True, partLoadStatus1)

workPart = theSession.Parts.Work
theSession.Parts.SetWork(workPart)

workPart = theSession.Parts.Work
' ----------------------------------------------
'   Dialog Begin New FEM and Simulation
' ----------------------------------------------
Dim caeDataContainer1 As CAE.CaeDataContainer
caeDataContainer1 = theSession.CaeSession.GetDataContainer()

caeDataContainer1.AddLogical("importToExisting", False)

caeDataContainer1.AddInteger("units", 4)

caeDataContainer1.AddLogical("searchForSolverFileUnits", False)

caeDataContainer1.AddLogical("useBtuThermalEnergyUnits", False)

caeDataContainer1.AddString("solverInputFileFormat", "ASCII")

caeDataContainer1.AddString("solverVersion", "NX 0")

caeDataContainer1.AddString("solverInputFileFullPath", "${inputFileName}")

caeDataContainer1.AddString("femFileName", "${tempFemPath}")

caeDataContainer1.AddString("simFileName", "${tempSimPath}")
<#-- EXAMPLE -->
<#-- caeDataContainer1.AddString("solverInputFileFullPath", "E:\Work\Novokshenov\CML\FCP\ISKPI\Nastran_testing\kub.dat")-->

<#--caeDataContainer1.AddString("femFileName", "E:\Work\Novokshenov\CML\FCP\ISKPI\Nastran_testing\kub_f.fem")-->

<#--caeDataContainer1.AddString("simFileName", "E:\Work\Novokshenov\CML\FCP\ISKPI\Nastran_testing\kub_s.sim")-->

caeDataContainer1.AddString("idealizedPartFileName", "")

caeDataContainer1.AddInteger("temperatureunit", 0)

caeDataContainer1.AddLogical("specifyTempUnit", False)

caeDataContainer1.AddInteger("selectiveImportMethod", 0)

caeDataContainer1.AddLogical("importCsys", True)

caeDataContainer1.AddLogical("importGrids", True)

caeDataContainer1.AddLogical("importElements", True)

caeDataContainer1.AddLogical("importMaterials", True)

caeDataContainer1.AddLogical("importPhysProps", True)

caeDataContainer1.AddLogical("importLoads", True)

caeDataContainer1.AddLogical("importConstraints", True)

caeDataContainer1.AddLogical("importDofs", True)

caeDataContainer1.AddLogical("importSsmos", True)

caeDataContainer1.AddLogical("importSssos", True)

caeDataContainer1.AddLogical("importOptimizationCards", True)

caeDataContainer1.AddLogical("importContacts", True)

caeDataContainer1.AddLogical("extendedDataChecking", False)

caeDataContainer1.AddLogical("roundTripImport", False)

caeDataContainer1.AddLogical("import3dMovAsField", False)

caeDataContainer1.AddLogical("importSelectiveLoadAsField", True)

Dim caePart1 As CAE.CaePart
caePart1 = theSession.CaeSession.ImportSimulation("NX NASTRAN", caeDataContainer1)

workPart = Nothing
Dim workSimPart As CAE.SimPart = CType(theSession.Parts.BaseWork, CAE.SimPart)

displayPart = Nothing
Dim displaySimPart As CAE.SimPart = CType(theSession.Parts.BaseDisplay, CAE.SimPart)

caeDataContainer1.Dispose()
Dim simPart1 As CAE.SimPart = CType(workSimPart, CAE.SimPart)

theSession.Post.UpdateUserGroupsFromSimPart(simPart1)

Dim markId4 As Session.UndoMarkId
markId4 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Enter Advanced Simulation")

' ----------------------------------------------
'   Menu: File->Export->Simulation...
' ----------------------------------------------
Dim caeDataContainer2 As CAE.CaeDataContainer
caeDataContainer2 = theSession.CaeSession.GetDataContainer()

caeDataContainer2.AddInteger("units", 4)

caeDataContainer2.AddString("solverInputFileFullPath", "${outputFileName}")

Dim tagvector1(0) As TaggedObject
Dim nullTaggedObject As TaggedObject = Nothing

tagvector1(0) = nullTaggedObject
caeDataContainer2.AddTaggedObjectVector("roundTripParam", tagvector1)

caeDataContainer2.AddInteger("subsetExportIndex", 0)

Dim tagvector2(-1) As TaggedObject
caeDataContainer2.AddTaggedObjectVector("subsetExportGroups", tagvector2)

caeDataContainer2.AddLogical("exportNasStatSection", True)

caeDataContainer2.AddLogical("exportFileMgmtSection", True)

caeDataContainer2.AddLogical("exportExecControlSection", True)

caeDataContainer2.AddLogical("exportCaseControlSection", True)

caeDataContainer2.AddLogical("exportSets", False)

caeDataContainer2.AddLogical("exportBulkDataSection", True)

caeDataContainer2.AddLogical("exportBeginEndData", True)

caeDataContainer2.AddLogical("exportParams", True)

Dim tagvector3(0) As TaggedObject
tagvector3(0) = nullTaggedObject
caeDataContainer2.AddTaggedObjectVector("additionalParam", tagvector3)

caeDataContainer2.AddLogical("exportCoordSys", True)

caeDataContainer2.AddLogical("exportNodes", True)

caeDataContainer2.AddLogical("exportElements", True)

caeDataContainer2.AddLogical("exportMaterials", True)

caeDataContainer2.AddLogical("exportPhysProps", True)

caeDataContainer2.AddLogical("exportLoads", True)

caeDataContainer2.AddLogical("exportConstraints", True)

caeDataContainer2.AddLogical("exportSimObjects", True)

caeDataContainer2.AddInteger("coordSysIdOffset", 0)

caeDataContainer2.AddInteger("nodeIdOffset", 0)

caeDataContainer2.AddInteger("elementIdOffset", 0)

caeDataContainer2.AddInteger("materialIdOffset", 0)

caeDataContainer2.AddInteger("physPropIdOffset", 0)

Dim tagvector4(0) As TaggedObject
tagvector4(0) = nullTaggedObject
caeDataContainer2.AddTaggedObjectVector("basicCsys", tagvector4)

caeDataContainer2.AddInteger("selectiveExportMethod", 0)

Dim stringarray1(-1) As String
caeDataContainer2.AddStrings("cardsToSkip", stringarray1)

caeDataContainer2.AddLogical("formattingCollapsed", True)

caeDataContainer2.AddLogical("subsetExportCollapsed", True)

caeDataContainer2.AddLogical("exportOptionsCollapsed", True)

caeDataContainer2.AddLogical("offsetCollapsed", True)

caeDataContainer2.AddLogical("modelOrientationCollapsed", True)

Dim simPart2 As CAE.SimPart = CType(workSimPart, CAE.SimPart)

simPart2.ExportSimulation("NX NASTRAN", caeDataContainer2)

caeDataContainer2.Dispose()
' ----------------------------------------------
'   Menu: Tools->Journal->Stop Recording
' ----------------------------------------------

End Sub
End Module