/**
 * Created by lexeek on 27.10.14.
 */

(function () {
  "use strict";

  window.App.Controllers.AdminController = Backbone.Marionette.Controller.extend({

    initialize: function (options) {
      this.mainWrapperView = window.App.MainWrapperView = window.App.MainWrapperView || new window.App.Views.AppMainWrapperView();
      window.App.mainAppContentRegion.show(this.mainWrapperView);
      this.adminView = new window.App.Views.AdminView(options);
      this.options.region = this.mainWrapperView.contentWrapperRegion;
    },

    showAdmin: function(options) {
      if (!window.App.Data.UserProfile.get("admin")) return false;
      this.adminView =  new window.App.Views.AdminView(this.options);
      options = _.extend(this.options || {}, options || {});
      options.region.show(this.adminView);
    },

    showNodesPage: function(options) {
      this.showAdmin();
      this.currentView = new window.App.Views.NodesView(_.extend(options || {}, {
        gridCollection: new App.Collections.Nodes([], { pageable: true }),
        actions: ["open"]
      }));
      this.adminView.setActiveMenuItem("nodes");
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showSolversPage: function(options) {
      this.showAdmin();
      this.currentView = new window.App.Views.Solvers(_.extend(options || {}, {
        gridCollection: new App.Collections.Solvers([], {pageable: true})
      }));
      this.adminView.setActiveMenuItem("solvers");
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showNodeByIdPage: function(options) {
      this.showAdmin();
      this.currentView = new window.App.Views.NodePage((_.extend({}, options)));
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showSolverByIdPage: function(options) {
      this.showAdmin();
      this.currentView = new window.App.Views.SolverPage((_.extend({}, options)));
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showNodesCreatePage: function (options) {
      this.showAdmin();
      this.currentView = new window.App.Views.NodesCreateNewView((_.extend({}, options)));
      this.adminView.setActiveMenuItem("nodes-create");
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showSolversCreatePage: function (options) {
      this.showAdmin();
      this.currentView = new window.App.Views.SolversCreateNewView((_.extend({}, options)));
      this.adminView.setActiveMenuItem("solvers-create");
      this.adminView.adminMainRegion.show(this.currentView);
    },

    showTclScriptsPage: function(options) {
      this.showAdmin();
      this.currentView = new window.App.Views.TclScriptsGrid(_.extend(options || {}, {
        gridCollection: new App.Collections.TclScripts([], { pageable: true }),
        actions: ["export", "delete"]
      }));
      this.adminView.setActiveMenuItem("tclScripts");
      this.adminView.adminMainRegion.show(this.currentView);
    }

  })
}());