/**
 * Created by lexeek on 14.09.14.
 */

(function () {
  "use strict";
  App.Views.AppMainWrapperView = Marionette.LayoutView.extend({

    className: "content-wrapper-view",
    template: "./views/templates/_content_wrapper.html.ejs",

    regions: {
      contentWrapperRegion: '#content-wrapper',
      sidebarWrapperRegion: "#sidebar-wrapper"
    },

    ui: {
      toggleSidebarBtn: "a[href='#menu-toggle'] i",
      sideBarWrapper: "#sidebar-wrapper",
      mainContentWrapper: "#main-content-wrapper"
    },

    events: {
      "click @ui.toggleSidebarBtn": "toggleSidebar"
    },

    startProjectWidth: 0,

    setPercentWidth: function () {
      var that = this;

      if (that.ui.sideBarWrapper.hasClass('sidebar-hidden')) {
        return;
      }

      var sbW = that.ui.sideBarWrapper.width()
      var mcW = that.ui.mainContentWrapper.width()
      var winW = $(window).width();
      var sbWPercents = sbW / (winW * 0.01);
      var mcWPercents = mcW / (winW * 0.01);

      var diff = 100 - (sbWPercents + mcWPercents);

      that.ui.mainContentWrapper.css("width", mcWPercents + "%")
      that.ui.sideBarWrapper.css("width", (sbWPercents + diff) + "%")
    },
    onShow: function () {
      var that = this;

      $(window).resize(function () {
        that.setPercentWidth();

      });

      that.sidebarWrapperRegion.on("show", function () {
        that.startProjectWidth = that.ui.mainContentWrapper.width();
        that.ui.sideBarWrapper.resizable({
          delay: 0,
          maxWidth: 920,
          width: "10%",
          minWidth: 320, //minSB width
          handles: 'e, h',
          height: "100%",
          autoHide: false,
          alsoResize: ".sidebar-tree",
          "alsoResizeReverse": "div#main-content-wrapper"
        });
      });

      that.setPercentWidth();
    },

    sideBarWidthBeforeHide: 0,

    toggleSidebar: function (e) {
      e.preventDefault();
      var that = this;
      var initialW = that.ui.sideBarWrapper.width();
      var initialCW = that.ui.mainContentWrapper.width();

      if (that.ui.sideBarWrapper.hasClass('sidebar-hidden')) {
        initialW = parseFloat(that.ui.sideBarWrapper.attr("_prevWidth"));
        that.ui.sideBarWrapper.animate({
            width: initialW
          },
          {
            start: function () {
              //$(this).removeClass("closed");
              $(this).show();
              that.ui.mainContentWrapper.animate({
                  width: $(window).width() - initialW
                },
                {complete: function () {

                }}
              );
            },
            complete: function () {
              $(this).removeClass("sidebar-hidden");
            }}
        );
      } else {
        that.ui.sideBarWrapper.attr('_percentWidth', initialW / ($(window).width() * 0.01));
        that.ui.sideBarWrapper.attr('_prevWidth', initialW);
        that.ui.mainContentWrapper.attr('_percentWidth', initialCW / ($(window).width() * 0.01));
        that.ui.mainContentWrapper.attr('_prevWidth', initialCW);

        that.ui.sideBarWrapper.animate({
            width: 0
          },
          {
            start: function () {
              that.ui.mainContentWrapper.animate({
                  width: $(window).width()
                },
                {complete: function () {
                  that.ui.mainContentWrapper.css('width', "100%");
                  console.log("app_main_wrapper width:", that.ui.mainContentWrapper.css('width'))
                }}
              );
            },
            complete: function () {
              $(this).addClass("sidebar-hidden");
              $(this).hide();
            }});
      }
      this.ui.toggleSidebarBtn.toggleClass("fa-toggle-left").toggleClass('fa-toggle-right');
    }

  });
}());