(function () {
  "use strict";

  window.App.Views.BaseControlsView = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/base/base_controls.html.ejs",
    className: "base-controls-view row",
    title: "",

    ui: {
      newBtn:    ".js-new",
      copyBtn:    ".js-copy",
      editBtn:    ".js-edit",
      saveBtn:    ".js-save",
      cancelBtn:  ".js-cancel",
      getResBtn: ".js-get-res",
      runTSBtn: ".js-run-ts",
      showLog: ".js-show-log"
    },

    events: {
      "click @ui.newBtn":     "onNewClick",
      "click @ui.copyBtn":     "onCopyClick",
      "click @ui.editBtn":    "onEditClick",
      "click @ui.saveBtn":    "onSaveClick",
      "click @ui.cancelBtn":  "onCancelClick",
      "click @ui.getResBtn":  "onGetResClick",
      "click @ui.runTSBtn":  "onRunTSClick",
      "click @ui.showLog":  "onShowLogClick"
    },

    initialize: function(options) {
      this.options = options || {};
      this.controls = this.options.controls;
      this.listenTo(this.model, "change", this.onModelChange);
    },

    onModelChange: function () {
      if (this.model.hasChanged('name')) this.render();
    },

    onNewClick: function() {
      this.options.layoutView.onNewClick();
    },

    onCopyClick: function() {
        this.options.layoutView.onCopyClick();
    },

    onEditClick: function() {
      this.options.layoutView.onEditClick();
    },

    onSaveClick: function() {
      this.options.layoutView.onSaveClick();
    },

    onCancelClick: function() {
      this.options.layoutView.onCancelClick();
    },

    onGetResClick: function() {
        this.options.layoutView.onGetResClick();
    },

    onRunTSClick: function() {
      this.options.layoutView.onRunTSClick();
    },

    onShowLogClick: function() {
        this.options.layoutView.onShowLogClick();
    },

    templateHelpers: function() {
      var that = this;
      return {
        title: this.model ? this.model.get("name") : this.options.title,
        inControls: function (control) {
          return _.indexOf(that.controls, control) != -1;
        },
        isView: this.options.mode == "view"
      }
    }

  });

})();