(function() {
  "use strict";
  window.App.Views.CompositeMaterialBasePage = window.App.Views.MaterialBasePage.extend({
    template: "./views/templates/project/material/material_base_page.html.ejs",
    regions: _.extend({
      layersRegion: ".js-layers-region"
    }, window.App.Views.MaterialBasePage.prototype.regions),

    className: function () {
      return this.options.mode + " composite-material-page";
    },

    onNewClick: function () {
      window.App.navigate("#project/compositeMaterials/create", { trigger: true });
    },

    onEditClick: function () {
      window.App.navigate("#project/compositeMaterials/" + this.model.id + "/" + this.page + "/edit", { trigger: true });
    },

    onSaveClick: function () {
      var that = this;
      this.model.save({}, {
        success: function () {
          window.App.navigate("#project/compositeMaterials/" + that.model.id + "/" + that.page + "/view", { trigger: true });
        },
        error: function (xhr) {
          console.error("Failed to save: ", xhr);
        }
      });
    },

    onCancelClick: function () {
      window.App.navigate("#project/compositeMaterials/" + this.model.id + "/" + this.page + "/view", { trigger: true });
    },

    onClickNavItem: function (e) {
      var $target = $(e.target).closest("li");
      if (!$target.hasClass("active"))
        window.App.navigate("#project/compositeMaterials/" + this.model.id + "/" + $target.data("route") + "/view");
    },

    initAndShowControlsView: function (region) {
      this.controlsView = new window.App.Views.MaterialControlsView({
        layoutView: this,
        model: this.model,
        controls: this.controls
      });
      region.show(this.controlsView);
    },

    templateHelpers: function () {
      return {
        active: this.page
      }
    }

  });

})();