(function () {
  "use strict";
  window.App.Views.CompositeMaterialFilesPage = window.App.Views.MaterialBasePage.extend({
    template: "./views/templates/project/composite_material/composite_material_base_page.html.ejs",
    initialize: function (options) {
      window.App.Views.MaterialBasePage.__super__.initialize.apply(this, arguments);
      this.controls = ["new"];
      this.page = this.options.fileType;
    },

    onShow: function () {
      this.initAndDrawTables();
    },

    initAndDrawTables: function () {
      var gridCollection = new window.App.Collections.Files([], {
        objectId: this.model.id,
        objectType: "compositeMaterials",
        fileType: this.options.fileType,
        pageable: true,
        filters: this.options.filters || null
      });

      this.filesView = new window.App.Views.FilesListView(_.extend({
        gridCollection: gridCollection,
        actions: ["open", "new", "export", 'delete'],
        isFile: this.options.isFile,
        title: this.parseFileType(this.options.fileType)
      }, {}));
      this.getRegion("mainRegion").show(this.filesView);
    },

    parseFileType: function (fileType) {
      var title = "";
      switch (fileType) {
        case "materialFiles":
          title = "Файлы Материала";
          break;
        case "sampleFiles":
          title = "Файлы Образцов";
          break;
        case "simulations":
          title = "Виртуальные Испытания";
          break
      }
      return title;
    }

  });

})();