(function() {
  "use strict";
  window.App.Views.ConstructionElementFilesPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/construction_element/construction_element_files_page.html.ejs",

    initialize: function (options) {
      window.App.Views.MaterialFilesPage.__super__.initialize.apply(this, arguments);
      this.controls = ["new"];
      this.page = this.options.fileType;
      this.pageTitle = this.model.get("name");
    },

    onShow: function () {
      this.initAndDrawTables();
    },

    initAndDrawTables: function () {
      this.filesView = new window.App.Views.FilesListView(_.extend({
        gridCollection: new window.App.Collections.Files([], {
          objectId: this.model.id,
          objectType: "constructionElements",
          fileType: this.options.fileType,
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["open", "new", "export", "delete"],
        isFile: true,
        title: this.parseTitle(this.options.fileType)
      }, {}));
      this.getRegion("mainRegion").show(this.filesView);
    },

    parseTitle: function (fileType) {
      var title = "Файлы";
      switch(fileType) {
        case "designSolutions":
          title = "Конструкторские решения";
          break;
        case "CADFiles":
          title = "CAD-файлы";
          break;
        case "CAEFiles":
          title = "CAE-файлы";
          break;
        case "CAOFiles":
          title = "CAO-файлы";
          break;
      }
      return title;
    }

  });

})();