(function () {
  "use strict";
  window.App.Views.ConstructionElementParametersPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/construction_element/construction_element_parameters_page.html.ejs",
    regions: _.extend({
      loadConditionRegion: ".js-loadCondition-region"
    }, window.App.Views.BasePage.prototype.regions),

    onRender: function () {
      this.initAndShowMainView(this.getRegion("mainRegion"));
      this.initAndShowLoadCondition(this.getRegion("loadConditionRegion"));
      window.App.Views.BasePage.prototype.onRender.call(this);
    },

    initAndShowMainView: function (region) {
      this.mainView = new window.App.Views.ConstructionElementMainView({
        layoutView: this,
        mode: this.mode,
        model: this.model
      });
      region.show(this.mainView);
    },

    initAndShowLoadCondition: function (region) {
      this.filesView = new window.App.Views.FilesListView(_.extend({
        gridCollection: new window.App.Collections.Files([], {
          objectType: "constructionElements",
          objectId: this.model.id,
          fileType: "loadConditions",
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["open", "new", "export", "delete"],
        isFile: true,
        title: "Условия Нагружения"
      }, {}));
      region.show(this.filesView);
    }

  });

})();