(function () {
  "use strict";

  window.App.Views.EffectiveCharacteristicDefectView = Marionette.ItemView.extend({
    template: "./views/templates/project/effective_characteristics/effective_characteristic_defect.html.ejs",
    tagName: "tr",
    ui: {
      "fieldIn": ".js-field"
    },

    events: {
      "change @ui.fieldIn": "onFieldInChange"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onFieldInChange: function (e) {
      var $target = $(e.target);
      var val = $target.val();
      var field = $target.data("field");
      this.model.set(field, val);
      this.model.save(null, {
        success: function () {
          window.alertify.success("Изменения успешно сохранены");
        }
      });
    },

    templateHelpers: function () {
      return {
        isView: this.options.mode == "view",
        twoOrThree: this.options.twoOrThree
      }
    }
  });

})();