(function () {
  "use strict";

  window.App.Views.EffectiveCharacteristicMainView = Marionette.LayoutView.extend({
    template: "./views/templates/project/effective_characteristics/effective_characteristic_main.html.ejs",
    className: "ui-effective-characteristic-main row",

    regions: {
      imageRegion: ".js-image-region"
    },

    ui: {
      name:         ".js-name"
    },

    events: {
      "keyup @ui.name":             "onChange",
      "keyup @ui.videoUrl":         "onChange",
      "change @ui.videoUrl":        "onChange",
      "keyup @ui.description":      "onChange"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onShow: function () {
      this.showImage();
    },

    showImage: function () {
      this.getRegion("imageRegion").show(new window.App.Views.BaseImageView({
        model: this.model,
        mode: this.options.mode,
        objectType: "effectiveCharacteristics",
        allowVerticalAlign: true
      }));
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = this.ui[key].val();
      if (key == "name") {
        if (value.length == 0) {
          this.ui.name.closest(".form-group").addClass("has-error");
          window.alertify.error("Название не может быть пустым.");
          return;
        } else {
          this.ui.name.closest(".form-group").removeClass("has-error");
        }
      }
      this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());