(function () {
  "use strict";

  window.App.Views.EffectiveCharacteristicMesoStructureView = Marionette.LayoutView.extend({
    template: "./views/templates/project/effective_characteristics/effective_characteristic_meso_structure.html.ejs",
    className: "ui-effective-characteristic-meso-structure clearfix",
    regions: {
      "defectsRegion": ".js-defects-region"
    },

    behaviors: {
      EffectiveCharacteristicBehaviors: {}
    },

    initialize: function () {
      if (this.options.microStructureHasImage) this.className = this.className + " clearfix";
    },

    onRender: function () {
      this.initAndShowDefects();
    },

    initAndShowDefects: function () {
      var that = this;
      this.defects = new window.App.Collections.EffectiveCharacteristicDefects({ effectiveCharacteristicId: this.options.effectiveCharacteristicId });
      this.defects.fetch({
        success: function () {
          that.getRegion("defectsRegion").show(new window.App.Views.EffectiveCharacteristicDefectsView({ collection: that.defects, mode: that.options.mode, twoOrThree: that.options.averageThicknessIsSetable }));
        }
      });
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view",
        averageThicknessIsSetable: this.options.averageThicknessIsSetable,
        effectiveCharacteristicId: this.options.effectiveCharacteristicId,
        getFieldByParameterId: function (options) {
          var parameter = _.findWhere(options.items, { parameterId: options.id });
          return parameter ? parameter[options.fieldName] : "";
        },
        mesoStructureHasImage: this.options.mesoStructureHasImage
      }
    }

  });

}());