(function () {
  "use strict";

  window.App.Views.MaterialDescriptionView = Marionette.LayoutView.extend({
    template: "./views/templates/project/material/material_description.html.ejs",
    className: "ui-material-description row",

    ui: {
      description: ".js-description"
    },

    events: {
      "keyup @ui.description":         "onChange",
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = this.ui[key].val();
      if (value.length != 0) this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());