(function () {
  "use strict";

  window.App.Views.AddDependencyToOptimization = Marionette.LayoutView.extend({
    template: "./views/templates/project/optimization/add_dependency_to_optimization.html.ejs",
    ui: {
      "select": ".js-select-dependency"
    },

    behaviors: function () {
      return {
        PluginsInit: {
          select2Events: [],
          select2: [
            window.App.Helpers.Select2Config({
              el: ".js-select-dependency",
              placeholder: "Выберите объект",
              url: "rest/" + this.options.type + "/suggest",
              isNumber: false,
              allowClear: true,
              minimumInputLength: 0
            })
          ]
        }
      }
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    passModal: function (md) {
      this.md = md;
    },

    onSubmit: function (md) {
      var that = this;
      md.preventClose();
      var id = this.ui.select.val();
      $.ajax({
        type: "POST",
        url: "rest/optimizations/" + this.options.optimizationId + "/" + this.options.type + "?entityId=" + id,
        success: function () {
          window.App.commands.execute("optimization:dependency:added", that.options.type);
          window.alertify.success("Усшешно добавлено");
          that.options.collection.fetch();
          md.close();
        }
      })
    }

  });

})();