window.OptimizationModeFrontierContainer = React.createClass({
  getInitialState: function () {
    var cadTabIsActive = !_.isNull(this.props.optimization.get("solverCadId"));
    var tab = this.props.tab ? parseInt(this.props.tab) : 1;
    if (!cadTabIsActive && tab == 2) {
      tab = 1;
    }
    return {
      cadTabIsActive: cadTabIsActive,
      tab: tab
    };
  },
  prepareTab: function () {
    let tabContent;
    switch(this.state.tab) {
      case 1:
        tabContent = <window.OptimizationModeFrontierScript isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      case 2:
        tabContent = <window.OptimizationModeFrontierCADBorders isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      case 3:
        tabContent = <window.OptimizationModeFrontierCAOBorders isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      case 4:
        tabContent = <window.OptimizationModeFrontierFunctions isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      case 5:
        tabContent = <window.OptimizationModeFrontierConstraints isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      case 6:
        tabContent = <window.OptimizationModeFrontierAlgorithm isView={this.props.isView} optimizationId={this.props.optimizationId} />;
        break;
      default:
        tabContent = <div>Default</div>;
        break;
    }
    return tabContent;
  },
  onNavigationClick: function (tab) {
    const mode = this.props.isView ? "view" : "edit";
    window.App.navigate("#project/optimizations/" + this.props.optimizationId + "/settings/" + mode + "/" + tab, { trigger: false });
    this.setState({ tab: tab });
  },
  render: function() {

    return (
      <div>
        <div className="js-settings-basic">
          <window.OptimizationSettingsBasic solverType={'ModeFrontier'} isView={this.props.isView} optimizationId={this.props.optimizationId}/>
        </div>
        <div className="js-settings-navigation">
          <window.OptimizationModeFrontierNavigation onClick={this.onNavigationClick} cadTabIsActive={this.state.cadTabIsActive} tab={this.state.tab} />
        </div>
        <div className="js-settings-set">
          {this.prepareTab()}
        </div>
      </div>
    )
  }
});