window.OptimizationModeFrontierScript = React.createClass({
  getInitialState: function () {
    return { code: "загружается ... "};
  },

  componentDidMount: function () {
    this.updateModel();
  },

  updateModel: function () {
    $.get("rest/optimizations/" + this.props.optimizationId + "/ModeFrontier/script", (response) => {
      this.setState({ code: response.code });
    })
  },

  onUploadClick: function () {
    this.createFileView = new window.App.Views.CreateFileView(_.extend({modal: this.createModal}, {
      url: "rest/optimizations/" + this.props.optimizationId + "/ModeFrontier/script",
      straightClose: true
    }));
    this.createModal = new Backbone.BootstrapModal({
      content: this.createFileView,
      title: "Загрузка Script'а",
      animate: true,
      cancelText: "Отменить",
      okText: "Сохранить"
    }).open();
    this.createFileView.passModal(this.createModal);
    this.createModal.on("close", () => {
      this.updateModel();
    });
  },

  prepareScriptHtml: function () {
    let html;
    if (_.isNull(this.state.code)) {
      html = "script.mac не загружен";
    } else if (typeof this.state.code === "string") {
      html = this.state.code;
    } else {
      html = this.state.code.map((string, index) => {
        return <window.OptimizationModeFrontierScriptString key={index} optimizationId={this.props.optimizationId} index={index} string={string}/>;
      });
    }
    return html;
  },

  render: function () {
    let code = this.prepareScriptHtml();
    return (
      <div className="ui-optimization-tab">
        <div className="row">
          <div className="col-md-10">
            <div className="ui-optimization-block">
              <div className="ui-optimization-block-header clearifx">
                <span className="pull-left">Определение варьируемых параметров</span>
                <button type="button" className="btn btn-warning btn-xs pull-right" onClick={this.onUploadClick}>Загрузить</button>
              </div>
              <div className="ui-optimization-block-body">
                <pre className="language-python ui-script-block-height">
                  <code className="language-python">{code}</code>
                </pre>
              </div>
            </div>
          </div>
          <div className="col-md-2">
            <window.OptimizationModeFrontierScriptParameters isView={this.props.isView} optimizationId={this.props.optimizationId} />
          </div>
        </div>
      </div>
    )
  }
});