window.OptimizationOptimusConstraint = React.createClass({
  getInitialState: function () {
    return this.props.data;
  },
  onFuncChange: function (e) {
    var state = this.state;
    state[e.target.id] = parseInt(e.target.value);
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.optimizationId + "/Optimus/constraints/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify(state),
      success: (data) => {
        this.setState(data);
      }
    });
  },
  onValueChange: function (e) {
    this.setState({ value: e.target.value });
  },

  onValueBlur: function (e) {
    if (this.validateValue()) {
      $.ajax({
        type: "PUT",
        url: "rest/optimizations/" + this.state.optimizationId + "/Optimus/constraints/" + this.state.id,
        contentType: "application/json",
        data: JSON.stringify(this.state),
        success: (data) => {
          this.setState(data);
        }
      });
    } else {
      window.alertify.error("Значение не валидно.")
    }
  },

  mapTypes: function () {
    var types = this.props.types.map((type)=> {
      return <option key={type.id} value={type.id}>{type.name}</option>
    });
    return types;
  },

  isValid: function () {
    return this.validateValue() && this.state.funcId != 4;
  },

  validateValue: function () {
    let reg = new RegExp('^(\-)?[0-9]+\.?[0-9]{0,4}$');
    return this.state.value && this.state.value.toString().match(reg);
  },

  render: function () {
    var formClass, btnClass;
    if (this.isValid()) {
      formClass = btnClass = "success";
    } else {
      formClass = "error";
      btnClass = "danger";
    }
    return (
      <div className="row" style={{"marginBottom": "7px"}}>
        <div className="col-md-1">
          <button type="button" className={"btn btn-" + btnClass} disabled>{this.state.name}</button>
        </div>
        <div className="col-md-2">
          <div className={"form-group has-" + formClass}>
            <select id="funcId" disabled={this.props.isView} className="form-control" value={this.state.funcId} onChange={this.onFuncChange}>
              {this.mapTypes()}
            </select>
          </div>
        </div>
        <div className="col-md-3">
          <div className={"form-group has-" + formClass}>
            <input className="form-control" disabled={this.props.isView} placeholder="Не задано" value={this.state.value || ""} onBlur={this.onValueBlur} onChange={this.onValueChange} />
          </div>
        </div>
      </div>
    )
  }
});