window.OptimizationOptistructConstraint = React.createClass({
  getInitialState: function () {
    return {
      data: this.props.data,
      attributes: {
        atta: [],
        attb: [],
        atti: [],
        ptype: []
      }
    };
  },

  componentWillMount: function () {
    this.fetchAttributes().then(()=> this.forceUpdate())
  },

  onChange: function (e) {
    let options = {name: e.target.id, value: e.target.value != -1 ? parseInt(e.target.value) : null};
    this.saveInputChanges(options);
  },

  onChangeInput: function (e) {
    var state = this.state.data;
    state[e.target.id] = _.isEmpty(e.target.value) ? null : e.target.value;
    this.setState({ data: state });
  },

  onBlur: function (e) {
    let options = {name: e.target.id, value: e.target.value};
    this.saveInputChanges(options);
  },

  saveInputChanges: function (options) {
    let updatedState = this.state.data;
    updatedState[options.name] = options.value;
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.data.optimizationId + "/Optistruct/constraints/" + this.state.data.id,
      contentType: "application/json",
      data: JSON.stringify(updatedState),
      success: () => {
        if (options.name == 'tfId') {
          this.fetchAttributes().then(() => this.fetchConstraint(), null)
        } else {
          this.forceUpdate();
        }
      }
    });
  },

  fetchAttributes: function () {
    return new Promise((resolve, reject) => {
      $.get("rest/optimizations/Optistruct/constraints/" + this.state.data.tfId + "/attributes").then((attributes) => {
        this.setState({ attributes: attributes });
        resolve();
      }, null);
    });
  },

  fetchConstraint: function () {
    $.get("rest/optimizations/" + this.state.data.optimizationId + "/Optistruct/constraints/" + this.state.data.id).then((response) => this.setState({ data: response }));
  },

  mapConstraintTypes: function () {
    return this.props.types.toJSON().map((type) => <option key={type.id} value={type.id}>{type.name}</option>)
  },

  mapLoadings: function () {
    return this.props.loadings.toJSON().map((loading) => <option key={loading.id} value={loading.id}>{loading.name}</option>);
  },

  mapSets: function () {
    return _.map(this.props.lnsets, (lnset) => <option key={lnset.id} value={lnset.id}>{lnset.name}</option>);
  },

  mapAttribute: function (attrName) {
    var valueInput = "";
    if (this.state.data[attrName + "Id"] == 1) {
      if (attrName == "atti") {
        valueInput = <select id={attrName + "Value"} style={{"marginTop": "5px"}} disabled={this.props.isView} className="form-control" onChange={this.onChange} value={this.state.data[attrName + "Value"] || undefined}>
          <option value="none">Не выбрано</option>
          {this.mapSets()}
        </select>
      } else {
        valueInput = <input id={attrName + "Value"} style={{"marginTop": "5px"}} disabled={this.props.isView} className="form-control" placeholder="Не задано" value={this.state.data[attrName + "Value"] || undefined} onChange={this.onChangeInput} onBlur={this.onBlur} />
      }
    }
    var isDisabled = _.isEmpty(this.state.attributes[attrName]);
    return (
      <div className={"form-group"}>
        <select id={attrName + "Id"} disabled={this.props.isView || isDisabled} className="form-control" value={this.state.data[attrName + "Id"] || undefined} onChange={this.onChange}>
        {this.state.attributes[attrName].map((option) => {
          return <option key={option.id} value={option.id}>{option.name}</option>
        })}
        </select>
        {valueInput}
      </div>
    )
  },

  render: function () {
    return (
      <div className="row" style={{"marginBottom": "7px"}}>
        <div className="col-md-12">
          <div className="ui-optimization-row-container clearfix">
            <div className="col-md-3">
              <div className={"form-group"}>
                <select id="tfId" disabled={this.props.isView} className="form-control" value={this.state.data.tfId || undefined} onChange={this.onChange}>
                    {this.mapConstraintTypes()}
                </select>
              </div>
            </div>
            <div className="col-md-2">
              {this.mapAttribute("atta")}
            </div>
            <div className="col-md-2">
              <div className={"form-group"}>
                <select id="loadingId" disabled={this.props.isView} className="form-control" value={this.state.data.loadingId || "none"} onChange={this.onChange}>
                  <option value="none">Не выбрано</option>
                  {this.mapLoadings()}
                </select>
              </div>
            </div>
            <div className="col-md-3">
                {this.mapAttribute("atti")}
            </div>
            <div className="col-md-2">
              <input id="lowerBound" disabled={this.props.isView} className="form-control" placeholder="Нижняя" value={this.state.data.lowerBound || undefined} onChange={this.onChangeInput} onBlur={this.onBlur} />
              <input id="upperBound" style={{"marginTop": "5px"}} disabled={this.props.isView} className="form-control" placeholder="Верхняя" value={this.state.data.upperBound || undefined} onChange={this.onChangeInput} onBlur={this.onBlur} />
            </div>
          </div>
        </div>
      </div>
    )
  }
});