var OptimizationOptistructLoadings = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/loadSteps";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptistructLoadings = React.createClass({
  getInitialState: function () {
    return {
      loadings: new OptimizationOptistructLoadings(null, {optimizationId: this.props.optimizationId}),
      parsedLoadings: [],
      calculationTypes: []
    };
  },

  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_LOAD_STEPS:changed", () => {
      this.fetchData().then(() => this.forceUpdate(), null);
    });
  },

  totalUpdate: function () {
    this.fetchData().then(() =>
        this.fetchParsedLoadings().then((parsedLoadings) =>
            this.fetchCalculationTypes().then((types) =>
                this.setState({ parsedLoadings: parsedLoadings, calculationTypes: types }),
              null),
          null),
      null);
  },

  fetchData: function () {
    return new Promise((resolve, reject) => {
      this.state.loadings.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchParsedLoadings: function () {
    return $.get("rest/optimizations/" + this.props.optimizationId + "/Optistruct/loadSteps/loads");
  },

  fetchCalculationTypes: function () {
    return $.get("rest/optimizations/" + this.props.optimizationId + "/Optistruct/loadSteps/calculationTypes");
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapLoadings: function () {
    return this.state.loadings.toJSON().map((loading) => {
      return <window.OptimizationOptistructLoading calculationTypes={this.state.calculationTypes}
                                                   parsedLoadings={this.state.parsedLoadings} isView={this.props.isView}
                                                   onChange={this.props.onChange} key={loading.id} data={loading}/>
    });
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Шаги нагружения</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-4">Нагрузки</div>
            <div className="col-md-4">Тип расчета</div>
            <div className="col-md-2">Закрепление</div>
          </div>
          {this.mapLoadings()}
        </div>
      </div>
    )
  }
});