var OptimizationBasic = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/" + this.options.solverType + "/basic";
  },

  initialize: function (collection, options) {
    this.options = options || {};
  }
});

window.OptimizationSettingsBasic = React.createClass({
  getInitialState: function () {
    return {
      settings: new OptimizationBasic(null, {
        optimizationId: this.props.optimizationId,
        solverType: this.props.solverType
      })
    };
  },
  componentDidMount: function () {
    this.state.settings.fetch().done(() => {
      this.forceUpdate()
    });
  },
  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },
  render: function () {
    var basicParameters = this.state.settings.toJSON().map((parameter) => {
      return <window.OptimizationSettingsBasicParameter solverType={this.props.solverType} isView={this.props.isView} key={parameter.id} data={parameter}/>
    });
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <div className="pull-left">Базовые параметры</div>
          <div className="btn-group pull-right">
            <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
              <span>Свернуть</span>
              <span style={{display: "none"}}>Развернуть</span>
            </button>
          </div>
        </div>
        <div className="ui-optimization-block-body">
          {basicParameters}
        </div>
      </div>
    )
  }
});