window.OptimizationToscaConstraint = React.createClass({
  getInitialState: function () {
    return this.props.data
  },

  componentWillMount: function () {
    this.mapGroups();
  },

  onChange: function (e) {
    let options = { name: e.target.id, value: e.target.value != -1 ? parseInt(e.target.value) : null };
    this.saveInputChanges(options);
  },

  onChangeInput: function (e) {
    let state = this.state;
    state[e.target.id] = e.target.value;
    this.setState(state);
  },

  onBlur: function (e) {
    let options = { name: e.target.id, value: e.target.value };
    this.saveInputChanges(options);
  },

  onChangeAbsoluteRelativeState: function (e) {
    let options = { name: "isAbsolute", value: e.target.value == 1 };
    this.saveInputChanges(options);
  },

  saveInputChanges: function (options) {
    let updatedState = this.state;
    updatedState[options.name] = options.value;
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.optimizationId + "/Tosca/constraints/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify(updatedState),
      success: (state) => this.setState(state)
    });
  },

  mapParameters: function () {
    var groupKey = 0;
    var parameters = _.map(this.props.parameters, (groupItems, groupName) => {
      return (
        <optgroup key={groupKey++} label={groupName}>
        {_.map(groupItems, (item) => {
          return <option key={item.id} value={item.id}>{item.name}</option>
        })}
        </optgroup>
      );
    });
    return parameters;
  },

  mapTypes: function () {
    var types = this.props.types.toJSON().map((type)=> {
      return <option key={type.id} value={type.id}>{type.name}</option>
    });
    return types;
  },

  mapGroups: function () {
    this.nodes = [];
    this.elements = [];
    _.each(this.props.sets.toJSON(), (setItem) => {
      let option = <option key={setItem.id} value={setItem.id}>{setItem.name}</option>;
      this[setItem.setTypeName.toLowerCase()].push(option)
    })
  },

  render: function () {
    return (
      <div className="row" style={{"marginBottom": "7px"}}>
        <div className="col-md-3">
          <div className={"form-group"}>
            <select id="parameterId" disabled={this.props.isView} className="form-control" value={this.state.parameterId || undefined} onChange={this.onChange}>
              {this.mapParameters()}
            </select>
          </div>
        </div>
        <div className="col-md-1">
          <div className={"form-group"}>
            <select id="typeId" disabled={this.props.isView} className="form-control" value={this.state.typeId || undefined} onChange={this.onChange}>
              {this.mapTypes()}
            </select>
          </div>
        </div>
        <div className="col-md-2">
          <div className={"form-group"}>
            <input id="value" disabled={this.props.isView} className="form-control" value={this.state.value || undefined} placeholder="Не задано" onChange={this.onChangeInput} onBlur={this.onBlur} />
          </div>
        </div>
        <div className="col-md-1">
          <div className={"form-group"}>
            <select disabled={this.props.isView} className="form-control" value={this.state.isAbsolute ? 1 : 2} onChange={this.onChangeAbsoluteRelativeState}>
              <option value={1}>Abs</option>
              <option value={2}>%</option>
            </select>
          </div>
        </div>
        <div className="col-md-2">
          <div className={"form-group"}>
            <select id="elementsGroupId" disabled={this.props.isView || !this.state.isElementGroupAllowed} className="form-control" value={this.state.elementsGroupId || -1} placeholder="Не задано" onChange={this.onChange}>
            <option value={-1}>Не задано</option>
            {this.elements}
            </select>
          </div>
        </div>
        <div className="col-md-2">
          <div className={"form-group"}>
            <select id="nodesGroupId" disabled={this.props.isView || !this.state.isNodesGroupAllowed} className="form-control" value={this.state.nodesGroupId || -1} placeholder="Не задано" onChange={this.onChange}>
            <option value={-1}>Не задано</option>
            {this.nodes}
            </select>
          </div>
        </div>
        <div className="col-md-1">
          <div className={"form-group"}>
            <input id="scalar" disabled={this.props.isView || !this.state.isScalarAllowed} className="form-control" value={this.state.scalar || undefined} placeholder="Не задано" onChange={this.onChangeInput} onBlur={this.onBlur} />
          </div>
        </div>
      </div>
    )
  }
});