var OptimizationToscaFunctions = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/targetFunctions";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

var OptimizationToscaFunctionTypes = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/targetFunctions/types";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

var OptimizationToscaFunctionSets = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/sets/selected";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationToscaFunctions = React.createClass({
  getInitialState: function () {
    return {
      functions: new OptimizationToscaFunctions(null, { optimizationId: this.props.optimizationId }),
      types: new OptimizationToscaFunctionTypes(null, { optimizationId: this.props.optimizationId }),
      sets: new OptimizationToscaFunctionSets(null, { optimizationId: this.props.optimizationId}),
      parameters: []
    };
  },
  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_TARGET_FUNCS:changed", () => {
      this.fetchData().then(() => this.forceUpdate(), null);
    });
  },

  totalUpdate: function () {
    this.fetchData().then(() =>
      this.fetchTypes().then(() =>
        this.fetchSets().then(() =>
          this.fetchParameters(), null),
        null),
    null);
  },

  fetchData: function () {
    return new Promise((resolve, reject) => {
      this.state.functions.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchTypes: function () {
    return new Promise((resolve, reject) => {
      this.state.types.fetch({
        success: resolve,
        error: reject
      })
    })
  },

  fetchSets: function () {
    return new Promise((resolve, reject) => {
      this.state.sets.fetch({
        success: resolve,
        error: reject
      })
    })
  },

  fetchParameters: function () {
    $.get("rest/optimizations/" + this.props.optimizationId + "/Tosca/targetFunctions/parameters", (parameters) => {
      this.setState({ parameters: parameters })
    });
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapFunctions: function () {
    var functions = this.state.functions.toJSON().map((func) => {
      return <window.OptimizationToscaFunction isView={this.props.isView} onChange={this.props.onChange} key={func.id} data={func} sets={this.state.sets} types={this.state.types} parameters={this.state.parameters}/>
    });
    return functions;
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение целевых функций</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-4">Параметр</div>
            <div className="col-md-2">Тип</div>
            <div className="col-md-2">Элементы</div>
            <div className="col-md-2">Узлы</div>
            <div className="col-md-2">Скаляр</div>
          </div>
          {this.mapFunctions()}
        </div>
      </div>
    )
  }
});