var OptimizationToscaAnimationParameter = Backbone.Model.extend({
  urlRoot: function () {
    return "rest/optimizations/" + this.collection.options.optimizationId + "/Tosca/animationParams";
  }
});

var OptimizationToscaAnimationParameters = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/animationParams";
  },

  initialize: function (models, options) {
    this.options = options || {};
  },

  model: OptimizationToscaAnimationParameter
});

window.OptimizationToscaAnimationParameters = React.createClass({
  getInitialState: function () {
    return {
      parameters: new OptimizationToscaAnimationParameters(null, { optimizationId: this.props.optimizationId })
    }
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  componentDidMount: function () {
    this.totalUpdate();
  },

  totalUpdate: function () {
    this.updateParameters().then(() => this.forceUpdate(), null);
  },

  updateParameters: function () {
    return new Promise((resolve, reject) => {
      this.state.parameters.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  render: function () {
    return (
      <div className="row">
        <div className="col-lg-12">
          <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
            <div className="ui-optimization-block-header clearfix">
              <span className="pull-left">Дополнительные параметры</span>
              <div className="btn-group pull-right">
                <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
                  <span>Свернуть</span>
                  <span style={{display: "none"}}>Развернуть</span>
                </button>
              </div>
            </div>
            <div className="ui-optimization-block-body">
              <div className="ui-optimization-algorithm-wrap">
                <form className="form-horizontal">
                  <window.OptimizationToscaSelectedMethodsParameters isView={this.props.isView} parameters={this.state.parameters} />
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    )
  }
});
