var OptimizationToscaSets = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/sets/selected";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationToscaSets = React.createClass({
  getInitialState: function () {
    return {
      sets: new OptimizationToscaSets(null, { optimizationId: this.props.optimizationId })
    };
  },

  componentDidMount: function () {
    this.fetchData();
    this.initSetsSuggest();
  },

  initSetsSuggest: function () {
    this.$setsSelect = $('.ui-suggest-sets');
    this.$setsSelect.select2(
      new window.App.Helpers.Select2Config({
        el: ".ui-suggest-sets",
        placeholder: "Выберите группу",
        url: "rest/optimizations/" + this.props.optimizationId + "/Tosca/sets/suggest",
        isNumber: false,
        allowClear: true,
        minimumInputLength: 0
      })
    ).on('change', this.onChooseSet)
  },

  onChooseSet: function (e) {
    var id = e.target.value;
    if (id) {
      $.ajax({
        type: "POST",
        url: 'rest/optimizations/' + this.props.optimizationId + "/Tosca/sets/" + e.target.value + "?isSelected=true",
        success: () => this.fetchData()
      });
    }
  },

  fetchData: function () {
    this.state.sets.fetch().done(() => {
      this.forceUpdate();
    });
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  onRemoveSet: function () {
    this.fetchData()
  },

  onExtractClick: function () {
    $.ajax({
      type: "POST",
      url: "rest/optimizations/" + this.props.optimizationId + "/Tosca/sets/extract",
      success: () => {
        window.alertify.success("Успешно");
        this.fetchData();
      }
    });
  },

  render: function () {
    let opts = {};
    if (this.props.isView) opts["disabled"] = "disabled";
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение наборов узлов</span>
          <button type="button" className="btn btn-primary btn-sm pull-right ui-extract-sets-btn" onClick={this.onExtractClick} {...opts}>Извлечь наборы</button>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row">
            <div className="col-md-6 ui-suggest-sets-wrap">
              <div className="form-group"><select className="form-control ui-suggest-sets" {...opts}></select></div>
            </div>
          </div>
          <div className="row ui-sets-wrap">
              {this.state.sets.toJSON().map((parameter) => {
                return <window.OptimizationToscaSet isView={this.props.isView} onRemoveSet={this.onRemoveSet} key={parameter.id} data={parameter}/>
              })}
          </div>
        </div>
      </div>
    )
  }
});