(function () {
  "use strict";

  var EmptyView = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/queue/queue_empty_cluster_nodes.html.ejs"
  });

  window.App.Views.QueueClusterNodesView = Backbone.Marionette.CompositeView.extend({
    template: "./views/templates/project/queue_cluster_nodes.html.ejs",
    className: "ui-queue-view",
    title: "Cluster Nodes",
    ui: {
      "filter": ".js-select-filter"
    },

    events: {
      "change @ui.filter": "onFilterChange"
    },

    initialize: function () {
      this.filterStatus = "all";
    },

    filter: function (child, index, collection) {
      return this.filterStatus === "all" || child.get("status") === this.filterStatus;
    },

    onFilterChange: function () {
      this.filterStatus = this.ui.filter.val();
      this.render();
    },

    templateHelpers: function () {
      return {
        clusterName: this.collection.at(0).get("clusterName"),
        status: this.filterStatus
      }
    },

    childViewContainer: ".js-queue-nodes",
    childView: window.App.Views.QueueClusterNodeView,
    emptyView: EmptyView
  });

})(); 