(function () {
  "use strict";

  window.App.Views.QueueStatisticsWrap = window.App.Views.CollapsableBlock.extend({
    template: "./views/templates/project/queue/queue_statistics_wrap.html.ejs",
    regions: {
      bodyRegion: ".js-body-region"
    },

    onShow: function () {
      this.initSockets();
    },

    initSockets: function () {
      var that = this;
      window.App.webSocketBus.stompClient.subscribe("/queue/clusters", function (frame) {
        var statistics = JSON.parse(frame.body);
        that.mapStatistics(statistics);
      });
    },

    mapStatistics: function (statistics) {
      this.showStatisticBars(statistics);
    },

    showStatisticBars: function (statistics) {
      if (this.getRegion("bodyRegion") && !this.getRegion("bodyRegion").hasView()) {
        this.statisticsView = new window.App.Views.QueueStatistics({ collection: new Backbone.Collection(statistics) });
        this.getRegion("bodyRegion").show(this.statisticsView);
      } else {
        this.statisticsView.collection.reset(statistics);
      }
    }

  });

})();