(function () {
  "use strict";

  var TasksGridView = window.App.Views.BackgridBasePageView.extend({
    id: "tasks-grid-view",
    title: "Очередь",
    contextMenuTemplate: "./views/templates/project/context_menu/project_queue_tasks_menu.html.ejs",
    initialize: function () {
      window.App.Views.BackgridBasePageView.prototype.initialize.apply(this, arguments);
      if (this.options.noContextMenuTemplate) this.contextMenuTemplate = null;
    }
  });

  window.App.Views.ProjectQueueTasksView = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/queue/project_queue_tasks.html.ejs",
    className: "queue-tasks",

    regions: {
      tasksGridRegion: "#tasks-backgrid-region"
    },

    initialize: function (options) {
      this.options = options || {};
      this.tasksGrid = new TasksGridView(_.extend(options, { showTools: false, selectable: true, draggableRows: this.options.draggableRows }));
    },

    onShow: function () {
      this.tasksGridRegion.show(this.tasksGrid);
    }

  });

})();