package ru.crp.lvms;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.test.context.support.WithSecurityContextTestExecutionListener;
import org.springframework.security.test.context.support.WithUserDetails;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.transaction.TransactionalTestExecutionListener;
import org.springframework.test.context.web.ServletTestExecutionListener;
import org.springframework.test.context.web.WebAppConfiguration;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.filter.CharacterEncodingFilter;
import ru.crp.lvms.model.entities.UserEntity;
import ru.crp.lvms.security.PortalUser;
import ru.crp.lvms.utils.ProjectCreator;

import static org.junit.Assert.assertTrue;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;

@RunWith(SpringJUnit4ClassRunner.class)
@Transactional
@ContextConfiguration(locations = {"/test-config.xml"})
@WebAppConfiguration()
@TestExecutionListeners(listeners = {ServletTestExecutionListener.class,
        DependencyInjectionTestExecutionListener.class,
        TransactionalTestExecutionListener.class,
        WithSecurityContextTestExecutionListener.class})
@WithUserDetails(value = "admin")
public class BaseIT {
    @Autowired
    protected WebApplicationContext webApplicationContext;

    @Autowired
    protected ObjectMapper jacksonMapper;

    protected MockMvc mockMvc;

    @Autowired
    protected ProjectCreator projectCreator;

    protected UserEntity currentUser;

    @Before
    public void setup() throws Exception {
        CharacterEncodingFilter filter = new CharacterEncodingFilter();
        filter.setEncoding("UTF-8");
        filter.setForceEncoding(true);

        mockMvc = MockMvcBuilders.webAppContextSetup(webApplicationContext)
                .addFilter(filter, "/*")
                .alwaysExpect(content().encoding("UTF-8"))
                .dispatchOptions(true).build();
        projectCreator.setMockMvc(mockMvc);
        projectCreator.createProjectData();
        currentUser = PortalUser.getCurrentUser().getUser();
    }

    @Test
    public void emptyTest() {
        assertTrue(true);
    }

}
