package ru.crp.lvms;

import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.entities.effective.characteristics.ECEntity;
import ru.crp.lvms.utils.TestUtils;
import ru.crp.lvms.utils.URLs;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

import static ru.crp.lvms.utils.TestUtils.unique;

public class EffectiveCharacteristicsEndpointIT extends CRUDIT<ECEntity, ECEntity> {
    @Override
    public String setUrl() {
        return URLs.EFFECTIVE_CHARACTERISTICS_URL;
    }

    @Override
    public Supplier<ECEntity> setEntityCreator() {
        return projectCreator::createEffectiveCharacteristicEntity;
    }

    @Override
    public Supplier<ECEntity> setEntityInitialisation() {
        return projectCreator::newEffectiveCharacteristicEntity;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::effectiveCharacteristicsFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::effectiveCharacteristicPageFromJson;
    }

    @Override
    public void update(ECEntity toUpdate) {
        toUpdate.setName(unique("new name"));
    }

    @Override
    public void validateAfterUpdate(ECEntity before, ECEntity after) {
        Assert.assertEquals(before.getName(), after.getName());
    }
}
