package ru.crp.lvms.optimizations;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import ru.crp.lvms.BaseIT;
import ru.crp.lvms.model.entities.FileEntity;
import ru.crp.lvms.model.entities.MaterialEntity;
import ru.crp.lvms.utils.TestUtils;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import static ru.crp.lvms.utils.URLs.OPTIMIZATION_FILES_URL;

public class OptimizationFilesIT extends BaseIT {

    private List<FileEntity> fileEntities;

    @Before
    public void createFiles() throws Exception {
        MaterialEntity materialEntity = projectCreator.createMaterial();
        fileEntities = Arrays.asList(
//                projectCreator.createMaterialFile(false),
//                projectCreator.createMaterialFile(false),
//                projectCreator.createMaterialFile(false),
//                projectCreator.createMaterialFile(false),
//                projectCreator.createMaterialFile(false)
        );
    }


    @Test
    @Ignore
    public void itMustAddOptFiles() throws Exception {
        List<Integer> ids = fileEntities.stream().map(FileEntity::getId).collect(Collectors.toList());
        JsonNode json = TestUtils.CREATEobject(mockMvc, OPTIMIZATION_FILES_URL + "/replace", ids);
        List<FileEntity> created = jacksonMapper.readValue(json.toString(), new TypeReference<List<FileEntity>>() {
        });
        long assertion1 = created.stream().map(FileEntity::getId).filter(ids::contains).count();
        long assertion2 = ids.stream().filter(created::contains).count();
        Assert.assertEquals(ids.size(), assertion1);
        Assert.assertEquals(created.size(), assertion2);
        json = TestUtils.GETobjects(mockMvc, OPTIMIZATION_FILES_URL);
        List<FileEntity> got = jacksonMapper.readValue(json.toString(), new TypeReference<List<FileEntity>>() {
        });
        long assertion3 = got.stream().map(FileEntity::getId).filter(ids::contains).count();
        Assert.assertEquals(ids.size(), assertion3);
    }

}
