package ru.crp.lvms.technologies;

import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.CRUDIT;
import ru.crp.lvms.model.entities.technology.TechnologyParametersEntity;
import ru.crp.lvms.utils.TestUtils;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

public class TechnologyParametersEndpointIT extends CRUDIT<TechnologyParametersEntity, TechnologyParametersEntity> {

    @Override
    public String setUrl() {
        return projectCreator.getUrlForTechnologyParameters();
    }

    @Override
    public Supplier<TechnologyParametersEntity> setEntityCreator() {
        return () -> projectCreator.createTechnologyParametersEntity();
    }

    @Override
    public Supplier<TechnologyParametersEntity> setEntityInitialisation() {
        return () -> projectCreator.newTechnologyParametersEntity();
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::technologyParametersFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::technologyParametersPageFromJson;
    }

    @Override
    public void update(TechnologyParametersEntity toUpdate) {
        toUpdate.setName("testName");
    }

    @Override
    public void validateAfterUpdate(TechnologyParametersEntity before, TechnologyParametersEntity after) {
        Assert.assertEquals(before.getName(), after.getName());
    }

    @Override
    public void testGet() throws Exception {
        super.testGet();
    }
}
