package ru.crp.lvms.managers.image;

import org.springframework.util.FileCopyUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class OldImageFilesManager {
    private final String filesPath;

    public OldImageFilesManager(String filesPath) {
        this.filesPath = filesPath;
    }

    public boolean delete(int id) {
        File fileToDelete = findFile(id);
        return fileToDelete != null && fileToDelete.exists() && fileToDelete.delete();
    }

    public File findFile(int id) {
        File folder = new File(filesPath);
        if (folder.exists() && folder.isDirectory()) {
            File[] files = folder.listFiles((dir, name) -> {
                return name.matches(id + "\\..+");
            });
            if (files != null && files.length > 0) {
                return files[0];
            }
        }
        return null;
    }

    public File findDefaultFile() {
        File defaultFile = new File(filesPath + "default.png");
        if (defaultFile.exists()) {
            return defaultFile;
        }
        return null;
    }

    public void save(int id, InputStream inputStream, String extension) throws IOException {
        File dir = new File(filesPath);
        if (!dir.exists()) {
            boolean dirsCreated = dir.mkdir();
            if (!dirsCreated) {
                throw new IllegalStateException("Can't create directory for image: " + dir);
            }
        }
        File file = new File(dir, id + "." + extension);
        FileOutputStream fos = new FileOutputStream(file);
        FileCopyUtils.copy(inputStream, fos);
    }
}
